
;CodeVisionAVR C Compiler V1.24.8a Evaluation
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : AT90S8535
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME AT90S8535
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0x30
	.EQU __sm_powerdown=0x20

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "asc.vec"
	.INCLUDE "asc.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Light
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Ascenseur 2006/2007
;      10 Version : 0.1
;      11 Date    : 19/02/2007
;      12 Author  : TOUZET / PETITJEAN
;      13 Company : Lycee Pierre-Emile MARTIN
;      14 Comments: 
;      15 Programme PPE Ascenseur
;      16 2006 / 2007
;      17 
;      18 
;      19 Chip type           : AT90S8535
;      20 Clock frequency     : 4,000000 MHz
;      21 Memory model        : Small
;      22 External SRAM size  : 0
;      23 Data Stack size     : 128
;      24 *********************************************/
;      25 
;      26 // I2C Bus functions
;      27 #asm
;      28    .equ __i2c_port=0x12
   .equ __i2c_port=0x12
;      29    .equ __sda_bit=3
   .equ __sda_bit=3
;      30    .equ __scl_bit=7
   .equ __scl_bit=7
;      31 #endasm
;      32 #include <i2c.h>
;      33 
;      34 // Afficheur LCD
;      35 #asm
;      36    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      37 #endasm
;      38 #include <lcd.h>
;      39 
;      40 // Chargement des librairies
;      41 #include <90s8535.h>    // librairie C ATMEL AT90S8535
;      42 #include <delay.h>      // Fonction delai
;      43 #include <tpavnum.h> 	// Table de transcodage du clavier numrique utilis
;      44 #include <ssi.h> 	// SP de dcodage de la trame issue du clavier PS2 et SP Afficheur LCD
;      45 #include <pavenum.h>    // Gestion d'un clavier numrique type PS2
;      46 #include <stdio.h>	// Fonctions standard entres / sorties
;      47 
;      48 // External Interrupt 0 service routine
;      49 interrupt [EXT_INT0] void ext_int0_isr(void)
;      50 {

	.CSEG
_ext_int0_isr:
;      51 
;      52 
;      53 //interrption INT0  cabler entre la carte SSI et la carte interface I2C
;      54 
;      55 
;      56 }
	RETI
;      57  
;      58 // Adresse CGRAM de l'afficheur LCD
;      59 #define Add_Caract0_CGRAM 0x40             //caractre 0
;      60 #define Add_Caract1_CGRAM 0x48		   //caractre 1
;      61 #define Add_Caract2_CGRAM 0x50             //caractre 2
;      62 #define Add_Caract3_CGRAM 0x58             //caractre 3
;      63 #define Add_Caract4_CGRAM 0x60             //caractre 4
;      64 #define Add_Caract5_CGRAM 0x68             //caractre 5
;      65 #define Add_Caract6_CGRAM 0x70             //caractre 6
;      66 #define Add_Caract7_CGRAM 0x78             //caractre 7
;      67 
;      68 // Adresses des Ports I2C
;      69 #define AD_BASE_PCF8574		0x40        // base I2C
;      70 #define AD_I2C_PORTA		0           // port A
;      71 #define AD_I2C_PORTB		1           // port B
;      72 #define AD_I2C_PORTC		2	    // port C
;      73 #define AD_I2C_PORTD		3           // port D
;      74 
;      75 
;      76 /*--------------------------------------------------------------------------------------------------------------------------
;      77 type 			Dsignation				      Commentaires		       
;      78 ----------------------------------------------------------------------------------------------------------------------------*/ 
;      79 char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur

	.DSEG
_display_buffer_ligne0:
	.BYTE 0x11
;      80 char display_buffer_ligne1[17]; 	       		// tampon ligne 1 de l'afficheur
_display_buffer_ligne1:
	.BYTE 0x11
;      81 char display_buffer_ligne2[17]; 			// tampon ligne 2 de l'afficheur
_display_buffer_ligne2:
	.BYTE 0x11
;      82 char display_buffer_ligne3[17]; 	       		// tampon ligne 3 de l'afficheur
_display_buffer_ligne3:
	.BYTE 0x11
;      83 
;      84 
;      85 // Caractres personnaliss placs dans la mmoire CGRAM du LCD
;      86 const unsigned char XXX[] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};         	     // @0 CGRAM

	.CSEG
;      87 const unsigned char XXX[] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};                // @1 CGRAM
;      88 const unsigned char XXX[] = {0x00, 0x0E, 0x0A, 0x0A, 0x0A, 0x0A, 0x1B, 0x00};    	     // @2 CGRAM
;      89 const unsigned char XXX[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00};                // @3 CGRAM
;      90 const unsigned char XXX[] = {0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00};                // @4 CGRAM
;      91 const unsigned char XXX[] = {0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00};                // @5 CGRAM
;      92 const unsigned char XXX[] = {0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00};                // @6 CGRAM
;      93 const unsigned char XXX[] = {0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00};                // @7 CGRAM                
;      94 
;      95 
;      96 void main(void)
;      97 {
_main:
;      98 // Declare your local variables here
;      99 /*--------------------------------------------------------------------------------------------------------------------------
;     100 type 			Dsignation				      Commentaires		       
;     101 ----------------------------------------------------------------------------------------------------------------------------*/
;     102 
;     103 // Input/Output Ports initialization
;     104 // Port A initialization
;     105 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     106 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     107 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     108 DDRA=0x00;
	OUT  0x1A,R30
;     109 
;     110 // Port B initialization
;     111 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     112 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     113 PORTB=0x00;
	OUT  0x18,R30
;     114 DDRB=0x00;
	OUT  0x17,R30
;     115 
;     116 // Port C initialization
;     117 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     118 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     119 PORTC=0x00;
	OUT  0x15,R30
;     120 DDRC=0x00;
	OUT  0x14,R30
;     121 
;     122 // Port D initialization
;     123 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
;     124 // State0=0 State1=0 State2=0 State3=0 State4=0 State5=0 State6=0 State7=0 
;     125 PORTD=0x00;
	OUT  0x12,R30
;     126 DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     127 
;     128 // Timer/Counter 0 initialization
;     129 // Clock source: System Clock
;     130 // Clock value: Timer 0 Stopped
;     131 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     132 TCNT0=0x00;
	OUT  0x32,R30
;     133 
;     134 // Timer/Counter 1 initialization
;     135 // Clock source: System Clock
;     136 // Clock value: Timer 1 Stopped
;     137 // Mode: Normal top=FFFFh
;     138 // OC1A output: Discon.
;     139 // OC1B output: Discon.
;     140 // Noise Canceler: Off
;     141 // Input Capture on Falling Edge
;     142 TCCR1A=0x00;
	OUT  0x2F,R30
;     143 TCCR1B=0x00;
	OUT  0x2E,R30
;     144 TCNT1H=0x00;
	OUT  0x2D,R30
;     145 TCNT1L=0x00;
	OUT  0x2C,R30
;     146 OCR1AH=0x00;
	OUT  0x2B,R30
;     147 OCR1AL=0x00;
	OUT  0x2A,R30
;     148 OCR1BH=0x00;
	OUT  0x29,R30
;     149 OCR1BL=0x00;
	OUT  0x28,R30
;     150 
;     151 // Timer/Counter 2 initialization
;     152 // Clock source: System Clock
;     153 // Clock value: Timer 2 Stopped
;     154 // Mode: Normal top=FFh
;     155 // OC2 output: Disconnected
;     156 ASSR=0x00;
	OUT  0x22,R30
;     157 TCCR2=0x00;
	OUT  0x25,R30
;     158 TCNT2=0x00;
	OUT  0x24,R30
;     159 OCR2=0x00;
	OUT  0x23,R30
;     160 
;     161 // External Interrupt(s) initialization
;     162 // INT0: On
;     163 // INT0 Mode: Rising Edge
;     164 // INT1: Off
;     165 GIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x3B,R30
;     166 MCUCR=0x03;
	LDI  R30,LOW(3)
	OUT  0x35,R30
;     167 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     168 
;     169 // Timer(s)/Counter(s) Interrupt(s) initialization
;     170 TIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x39,R30
;     171 
;     172 // Analog Comparator initialization
;     173 // Analog Comparator: Off
;     174 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     175 // Analog Comparator Output: Off
;     176 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     177 
;     178 // I2C Bus initialisation
;     179 i2c_init();
	RCALL _i2c_init
;     180 
;     181 // LCD module initialisation
;     182 lcd_init(20);        
	LDI  R30,LOW(20)
	ST   -Y,R30
	RCALL _lcd_init
;     183 
;     184 // Chargement de la mmoire CGRAM de l'afficheur avec les 
;     185 // caractres personaliss
;     186 for (i=0;i<8;i++)
;     187 lcd_write_byte(Add_Caract0_CGRAM + i, caractre...[i]);
	RCALL SUBOPT_0x1
;     188 for (i=0;i<8;i++)
;     189 lcd_write_byte(Add_Caract1_CGRAM + i, caractre...[i]); 
	RCALL SUBOPT_0x1
;     190 for (i=0;i<8;i++)
;     191 lcd_write_byte(Add_Caract2_CGRAM + i, caractre...[i]);
	RCALL SUBOPT_0x1
;     192 for (i=0;i<8;i++)
;     193 lcd_write_byte(Add_Caract3_CGRAM + i, caractre...[i]);
	RCALL SUBOPT_0x1
;     194 for (i=0;i<8;i++)
;     195 lcd_write_byte(Add_Caract4_CGRAM + i, caractre...[i]);
	RCALL SUBOPT_0x1
;     196 for (i=0;i<8;i++)
;     197 lcd_write_byte(Add_Caract5_CGRAM + i, caractre...[i]); 
	RCALL SUBOPT_0x1
;     198 for (i=0;i<8;i++)
;     199 lcd_write_byte(Add_Caract6_CGRAM + i, caractre...[i]);
	RCALL SUBOPT_0x1
;     200 for (i=0;i<8;i++)
;     201 lcd_write_byte(Add_Caract7_CGRAM + i, caractre...[i]);
	RCALL SUBOPT_0x1
;     202 
;     203 // Dfinition des variables
;     204 unsigned char Lire_PCF8574(unsigned char add);
;	Lire_PCF8574 -> R16
;     205 unsigned char Ecrire_valeur(unsigned char x, unsigned char y);
	RCALL SUBOPT_0x2
;	Lire_PCF8574 -> R16
;	Ecrire_valeur -> Y+16
;	Lire_PCF8574 -> R16
;	Ecrire_valeur -> Y+32
;	y -> Y+16
;     206 unsigned char etat,i,j,PO1,PO2,PO3,PC1,PC2,PC3,AP1,AP2,AP3;
;     207 unsigned char AC1,AC2,AC3,VP1,VP2,VP3,EL1,EL2,EL3,DEF,LED1;
;     208 unsigned char LED2,LED3,OPTO1,OPTO2,OPTO3,PWM;
;     209 
;     210 // Prototype des fonctions
;     211 void Ecrire_PCF8574(unsigned char add, unsigned char valeur_portD);
	SBIW R28,28
;	Lire_PCF8574 -> R16
;	Ecrire_valeur -> Y+76
;	y -> Y+60
;	etat -> Y+44
;	i -> Y+43
;	j -> Y+42
;	PO1 -> Y+41
;	PO2 -> Y+40
;	PO3 -> Y+39
;	PC1 -> Y+38
;	PC2 -> Y+37
;	PC3 -> Y+36
;	AP1 -> Y+35
;	AP2 -> Y+34
;	AP3 -> Y+33
;	AC1 -> Y+32
;	AC2 -> Y+31
;	AC3 -> Y+30
;	VP1 -> Y+29
;	VP2 -> Y+28
;	VP3 -> Y+27
;	EL1 -> Y+26
;	EL2 -> Y+25
;	EL3 -> Y+24
;	DEF -> Y+23
;	LED1 -> Y+22
;	LED2 -> Y+21
;	LED3 -> Y+20
;	OPTO1 -> Y+19
;	OPTO2 -> Y+18
;	OPTO3 -> Y+17
;	PWM -> Y+16
;	Lire_PCF8574 -> R16
;	Ecrire_valeur -> Y+92
;	y -> Y+76
;	etat -> Y+60
;	i -> Y+59
;	j -> Y+58
;	PO1 -> Y+57
;	PO2 -> Y+56
;	PO3 -> Y+55
;	PC1 -> Y+54
;	PC2 -> Y+53
;	PC3 -> Y+52
;	AP1 -> Y+51
;	AP2 -> Y+50
;	AP3 -> Y+49
;	AC1 -> Y+48
;	AC2 -> Y+47
;	AC3 -> Y+46
;	VP1 -> Y+45
;	VP2 -> Y+44
;	VP3 -> Y+43
;	EL1 -> Y+42
;	EL2 -> Y+41
;	EL3 -> Y+40
;	DEF -> Y+39
;	LED1 -> Y+38
;	LED2 -> Y+37
;	LED3 -> Y+36
;	OPTO1 -> Y+35
;	OPTO2 -> Y+34
;	OPTO3 -> Y+33
;	PWM -> Y+32
;	valeur_portD -> Y+16
;     212 void PWM1(unsigned long alpha1);
	RCALL SUBOPT_0x2
;     213 void SP1(rampe accel);
;     214 void SP2(rampe decel);
	RCALL SUBOPT_0x2
;     215 
;     216 void PWM1(unsigned long alpha1)
;     217     {
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
;     218     unsigned short maxi;
;     219     maxi=0x00FF;
	SBIW R28,2
;	Ecrire_valeur -> Y+94
;	y -> Y+78
;	etat -> Y+62
;	i -> Y+61
;	j -> Y+60
;	PO1 -> Y+59
;	PO2 -> Y+58
;	PO3 -> Y+57
;	PC1 -> Y+56
;	PC2 -> Y+55
;	PC3 -> Y+54
;	AP1 -> Y+53
;	AP2 -> Y+52
;	AP3 -> Y+51
;	AC1 -> Y+50
;	AC2 -> Y+49
;	AC3 -> Y+48
;	VP1 -> Y+47
;	VP2 -> Y+46
;	VP3 -> Y+45
;	EL1 -> Y+44
;	EL2 -> Y+43
;	EL3 -> Y+42
;	DEF -> Y+41
;	LED1 -> Y+40
;	LED2 -> Y+39
;	LED3 -> Y+38
;	OPTO1 -> Y+37
;	OPTO2 -> Y+36
;	OPTO3 -> Y+35
;	PWM -> Y+34
;	valeur_portD -> Y+18
;	maxi -> Y+0
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	ST   Y,R30
	STD  Y+1,R31
;     220     OCR1A=maxi-(((100-alpha1) * maxi)/100);
	MOV  R26,R28
	MOV  R27,R29
	RCALL __GETW1P
	__PUTW1R 22,23
	SUB  R26,R30
	LD   R30,Y
	LDD  R31,Y+1
	LDI  R27,0
	SBRC R26,7
	SER  R27
	RCALL __MULW12U
	MOV  R26,R30
	MOV  R27,R31
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	MOV  R26,R30
	MOV  R27,R31
	__GETW1R 22,23
	SUB  R30,R26
	SBC  R31,R27
	OUT  0x2A+1,R31
	OUT  0x2A,R30
;     221     }
	ADIW R28,2
;     222 
;     223 void SP1(rampe accel)
;     224     {
	RCALL SUBOPT_0x3
;     225      i=0;
;     226      do
_0x1C:
;     227       {
;     228       i=i+1;
	LDD  R30,Y+59
	SUBI R30,-LOW(1)
	STD  Y+59,R30
;     229       delay_ms(10);
	RCALL SUBOPT_0x4
;     230       PWM1(i);
	LDD  R30,Y+59
;     231       }
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
;     232      while (((i<255)));
	LDD  R26,Y+59
	CPI  R26,LOW(0xFF)
	BRLO _0x1C
;     233     }
;     234 
;     235 void SP2(rampe decel)
;     236     {
	RCALL SUBOPT_0x3
;     237      i=0;
;     238      do
_0x1F:
;     239       {
;     240       j=j+1;
	LDD  R30,Y+58
	SUBI R30,-LOW(1)
	STD  Y+58,R30
;     241       delay_ms(10);
	RCALL SUBOPT_0x4
;     242       PWM1(j);
	LDD  R30,Y+58
;     243       }
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
;     244      while (((j<255)));
	LDD  R26,Y+58
	CPI  R26,LOW(0xFF)
	BRLO _0x1F
;     245     }
;     246 
;     247 // Global enable interrupts
;     248 #asm("sei")
	sei
;     249 
;     250 // initialisation :
;     251 //----------------
;     252 sprintf(display_buffer_ligne0,"   PPE ascenseur");
	RCALL SUBOPT_0x5
	__POINTW1FN _0,0
	RCALL SUBOPT_0x6
;     253 sprintf(display_buffer_ligne1,"    2006 / 2007");
	RCALL SUBOPT_0x7
	__POINTW1FN _0,17
	RCALL SUBOPT_0x6
;     254 sprintf(display_buffer_ligne2,"     Carte SSI");
	RCALL SUBOPT_0x8
	__POINTW1FN _0,33
	RCALL SUBOPT_0x6
;     255 sprintf(display_buffer_ligne3,"  Lyce P-E MARTIN");
	RCALL SUBOPT_0x9
	__POINTW1FN _0,48
	RCALL SUBOPT_0x6
;     256 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
	RCALL SUBOPT_0xA
;     257 delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0xB
;     258 
;     259 //initialisation : faire descendre la cabine jusqu' l'tage
;     260 while ((1))                     
_0x21:
;     261  {
;     262  PC1 = Lire_PCF8574(1)&0b00000001;        //entres port A
	RCALL SUBOPT_0xC
;     263  LED1 = Ecrire_PCF8574(3) 0b00000100      //  revoir
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,38
	RCALL SUBOPT_0xD
;     264  LED2 = Ecrire_PCF8574(3) 0b00000101      //  revoir
	LDI  R30,LOW(4)
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,37
	RCALL SUBOPT_0xD
;     265  LED3 = Ecrire_PCF8574(3) 0b00000110      //  revoir
	LDI  R30,LOW(5)
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,36
	RCALL SUBOPT_0xD
;     266  DEF = Ecrire_PCF8574(3) 0b00000111       //  revoir
	LDI  R30,LOW(6)
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,39
	RCALL SUBOPT_0xD
;     267 
;     268   while (((PC1==0)))                         
	LDI  R30,LOW(7)
_0x24:
	LDD  R30,Y+54
	CPI  R30,0
	BRNE _0x26
;     269     {
;     270     PWM1(255);
	LDI  R30,LOW(255)
;     271     LED1=1;
	RCALL SUBOPT_0xE
	STD  Y+38,R30
;     272     LED2=1;
	RCALL SUBOPT_0xF
;     273     LED3=1;
	RCALL SUBOPT_0x10
;     274     DEF=1;
	LDI  R30,LOW(1)
	STD  Y+39,R30
;     275     delay_ms(500);
	RCALL SUBOPT_0x11
;     276     LED1=0;
	LDI  R30,LOW(0)
	STD  Y+38,R30
;     277     LED2=0;
	STD  Y+37,R30
;     278     LED3=0;
	STD  Y+36,R30
;     279     DEF=0;
	STD  Y+39,R30
;     280     }
	RJMP _0x24
_0x26:
;     281   PWM1(0);
	RCALL SUBOPT_0x12
;     282  }
	RJMP _0x21
;     283 
;     284 
;     285 
;     286 //commander le moteur jusqu' ce que PC1=1
;     287 //ET en mme temps allumer les 3 LED (LED1.LED2.LED3)
;     288 //ET en mme temps afficher :
;     289 sprintf(display_buffer_ligne0,"   Initialisation");
;     290 sprintf(display_buffer_ligne1,"        ----");
;     291 sprintf(display_buffer_ligne2,"  Mode Autonome");
;     292 sprintf(display_buffer_ligne3,"  Monte interdite");
;     293 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     294 
;     295 while (1)
;     296       {
;     297       AP1 = Lire_PCF8574(0)&0b01000000;        //entres port A et B
;     298       AP2 = Lire_PCF8574(0)&0b10000000;
;     299       AP3 = Lire_PCF8574(1)&0b00000001;
;     300       
;     301       AC1 = Lire_PCF8574(1)&0b00000010;        //entres port B
;     302       AC2 = Lire_PCF8574(1)&0b00000100;
;     303       AC3 = Lire_PCF8574(1)&0b00001000;
;     304       
;     305       PO1 = Lire_PCF8574(0)&0b00001000;        //entres port A
;     306       PO2 = Lire_PCF8574(0)&0b00010000;
;     307       PO3 = Lire_PCF8574(0)&0b00100000;
;     308       
;     309       VP1 = Lire_PCF8574(2)&0b00000001;        //entres port C
;     310       VP2 = Lire_PCF8574(2)&0b00000010;
;     311       VP3 = Lire_PCF8574(2)&0b00000100;
;     312       
;     313       PC1 = Lire_PCF8574(1)&0b00000001;        //entres port A
;     314       PC2 = Lire_PCF8574(1)&0b00000010;
;     315       PC3 = Lire_PCF8574(1)&0b00000100;
;     316       
;     317  /*   commandes de sorties : a revoir
;     318       EL1 = Ecrire_PCF8574(AD_I2C_PORTD,0bOOOOOOO1);        //sorties port D
;     319       EL2 = Ecrire_PCF8574(3) 0bOOOOOO1O
;     320       EL3 = Ecrire_PCF8574(3) 0b00000011
;     321       LED1 = Ecrire_PCF8574(3) 0b00000100
;     322       LED2 = Ecrire_PCF8574(3) 0b00000101
;     323       LED3 = Ecrire_PCF8574(3) 0b00000110
;     324       DEF = Ecrire_PCF8574(3) 0b00000111      */
;     325       
;     326       
;     327       switch (etat);
;     328       case etage_1 : EL1 = 1;
;     329                      LED1 = 1;
;     330                      sprintf(display_buffer_ligne0,"Etage 1");
;     331                      sprintf(display_buffer_ligne1,"");
;     332                      sprintf(display_buffer_ligne2,"attente appel");
;     333                      sprintf(display_buffer_ligne3,"porte 1 deverouillee");
;     334                      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     335                 if ((AP2 == 1)||(AC2 == 1));
_0x30:
;     336        	       	 {
;     337        	  	   do//crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
_0x33:
;     338        	  	    {
;     339        	  	    sprintf(display_buffer_ligne0,"etage 2 demand");
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x6
;     340        	  	    sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x6
;     341                     sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x6
;     342        	            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
	RCALL SUBOPT_0x1B
;     343        	            etat = MC;
;     344                     while(PO1=1);
_0x35:
	RCALL SUBOPT_0x1C
	BRNE _0x35
;     345                     }
;     346                  }    
;     347        	       	else if  ((AP3 == 1)||(AC3 == 1))
	RCALL SUBOPT_0x1D
	BRNE _0x33
	RCALL SUBOPT_0x1E
	BREQ _0x39
	RCALL SUBOPT_0x1F
	BREQ _0x39
	RJMP _0x38
_0x39:
;     348        	       	 {
;     349        	  	   do//crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
_0x3C:
;     350        	  	   {
;     351        	  	   sprintf(display_buffer_ligne0,"etage 3 demand");
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x6
;     352        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x6
;     353                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x6
;     354        	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
	RCALL SUBOPT_0x1B
;     355        	           etat = ML;
;     356        	           while(PO1=1);
_0x3E:
	RCALL SUBOPT_0x1C
	BRNE _0x3E
;     357        	           }
;     358                  }
;     359                 else etat = etage_1;
	RCALL SUBOPT_0x1D
	BRNE _0x3C
	RCALL SUBOPT_0x21
;     360       break;
	RJMP _0x29
;     361       case etage_2 :  EL2 = 1;
;     362                       LED2 = 1;
;     363                       sprintf(display_buffer_ligne0,"Etage 2");
;     364                       sprintf(display_buffer_ligne1,"");
;     365                       sprintf(display_buffer_ligne2,"attente appel");
;     366                       sprintf(display_buffer_ligne3,"porte 2 deverouillee");
;     367                       Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     368                 if ((AP1 == 1)||(AC1 == 1));
_0x43:
;     369                  {
;     370        	  	   do//crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
_0x46:
;     371        	  	   {
;     372        	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x6
;     373        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x6
;     374                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x6
;     375        	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
	RCALL SUBOPT_0x1B
;     376        	           etat = DC;
;     377        	           while(PO2=1); 
_0x48:
	RCALL SUBOPT_0x25
	BRNE _0x48
;     378                    }
;     379                  }
;     380        	       	else if  ((AP3 == 1)||(AC3 == 1))
	RCALL SUBOPT_0x1D
	BRNE _0x46
	RCALL SUBOPT_0x1E
	BREQ _0x4C
	RCALL SUBOPT_0x1F
	BREQ _0x4C
	RJMP _0x4B
_0x4C:
;     381        	       	 {
;     382        	  	   do//crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
_0x4F:
;     383        	  	   {
;     384        	  	   sprintf(display_buffer_ligne0,"etage 3 demand");
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x6
;     385        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x6
;     386                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x6
;     387        	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
	RCALL SUBOPT_0x1B
;     388        	           etat = ML;
;     389                    while(PO2=1);
_0x51:
	RCALL SUBOPT_0x25
	BRNE _0x51
;     390                    }
;     391                  }
;     392        	       	else etat = etage_2;
	RCALL SUBOPT_0x1D
	BRNE _0x4F
	RCALL SUBOPT_0x21
;     393       break;
	RJMP _0x29
;     394       case etage_3 :  EL3 = 1;
_0x41:
	RCALL __CPD10
	BRNE _0x54
	LDI  R30,LOW(1)
	STD  Y+40,R30
;     395                       LED3 = 1;
	RCALL SUBOPT_0x10
;     396                       sprintf(display_buffer_ligne0,"etage 3");
	RCALL SUBOPT_0x5
	__POINTW1FN _0,271
	RCALL SUBOPT_0x6
;     397                       sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x6
;     398                       sprintf(display_buffer_ligne2,"attente appel");
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x6
;     399                       sprintf(display_buffer_ligne3,"porte 3 deverouillee");
	RCALL SUBOPT_0x9
	__POINTW1FN _0,279
	RCALL SUBOPT_0x6
;     400                       Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
	RCALL SUBOPT_0xA
;     401                 if ((AP1 == 1)||(AC1 == 1));
	RCALL SUBOPT_0x22
	BREQ _0x56
	RCALL SUBOPT_0x23
	BREQ _0x56
_0x56:
;     402                  {
;     403        	  	   do//crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
_0x59:
;     404        	  	   {
;     405        	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x6
;     406        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x6
;     407                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x6
;     408        	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
	RCALL SUBOPT_0x1B
;     409        	           etat = DL; 
;     410                    while(PO3=1);
_0x5B:
	RCALL SUBOPT_0x26
	BRNE _0x5B
;     411                    }
;     412                  }
;     413        	       	else if  ((AP2 == 1)||(AC2 == 1))
	RCALL SUBOPT_0x1D
	BRNE _0x59
	RCALL SUBOPT_0x17
	BREQ _0x5F
	RCALL SUBOPT_0x18
	BREQ _0x5F
	RJMP _0x5E
_0x5F:
;     414        	       	 {
;     415        	  	   do//crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
_0x62:
;     416        	  	   {
;     417        	  	   sprintf(display_buffer_ligne0,"etage 2 demand");
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x6
;     418        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x6
;     419                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x6
;     420        	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
	RCALL SUBOPT_0x1B
;     421        	           etat = DC;
;     422        	           while(PO3=1);
_0x64:
	RCALL SUBOPT_0x26
	BRNE _0x64
;     423                    }
;     424                  }
;     425                  else etat = etage_3
	RCALL SUBOPT_0x1D
	BRNE _0x62
;     426       break;
	RCALL SUBOPT_0x21
	RJMP _0x29
;     427       case MC : PWM1(0);
_0x54:
	RCALL __CPD10
	BRNE _0x67
	RCALL SUBOPT_0x12
;     428                 while ((1))                     
_0x68:
;     429                  {
;     430                 while (((PO1==0))||((PO2==0))||((PO3==0)))                        
_0x6B:
	RCALL SUBOPT_0x27
	BREQ _0x6E
	RCALL SUBOPT_0x28
	BREQ _0x6E
	RCALL SUBOPT_0x29
	BRNE _0x6D
_0x6E:
;     431                  {
;     432                  }
	RJMP _0x6B
_0x6D:
;     433                  if (((VP1==1)&&(VP2==1)&&(VP3==1)))                            
	RCALL SUBOPT_0x2A
	BRNE _0x71
	RCALL SUBOPT_0x2B
	BRNE _0x71
	RCALL SUBOPT_0x2C
	BREQ _0x72
_0x71:
	RJMP _0x70
_0x72:
;     434                   {
;     435                   SP1(rampe accel);
;     436                   delay_ms(500);
	RCALL SUBOPT_0x2D
;     437                   SP2(rampe decel);
;     438                   }
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
;     439                  else
	RJMP _0x73
_0x70:
;     440                   {
;     441                   etat=erreur;
	RCALL SUBOPT_0x21
;     442                   };
_0x73:
;     443                 while (((PC2==0))||((PC3==0)))                                
_0x74:
	RCALL SUBOPT_0x2E
	BREQ _0x77
	LDD  R26,Y+52
	CPI  R26,LOW(0x0)
	BRNE _0x76
_0x77:
;     444                   {
;     445                   }
	RJMP _0x74
_0x76:
;     446                   PWM1(0);
	RCALL SUBOPT_0x12
;     447                   if (((PC2==1)))                        
	RCALL SUBOPT_0x2F
	BRNE _0x79
;     448                    {
;     449                    etat=etage_2;
	RJMP _0xC0
;     450                    }
;     451                   else
_0x79:
;     452                    {
;     453                    if (((PC3==1)))                        
	LDD  R26,Y+52
	CPI  R26,LOW(0x1)
	BRNE _0x7B
;     454                    {
;     455                    etat=etage_3;
;     456                    }
;     457                   else
_0x7B:
;     458                    {
;     459                    etat=erreur;
_0xC0:
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,60
	RCALL SUBOPT_0x30
;     460                    };
;     461                    };
;     462                  }
	RJMP _0x68
;     463       break; 	
;     464       case DC : PWM(0);
_0x67:
	RCALL __CPD10
	BRNE _0x7D
	RCALL SUBOPT_0x31
;     465                 while ((1))                     
_0x7E:
;     466                  {
;     467                 while (((PO1==0))||((PO2==0))||((PO3==0)))                        
_0x81:
	RCALL SUBOPT_0x27
	BREQ _0x84
	RCALL SUBOPT_0x28
	BREQ _0x84
	RCALL SUBOPT_0x29
	BRNE _0x83
_0x84:
;     468                  {
;     469                  }
	RJMP _0x81
_0x83:
;     470                  if (((VP1==1)&&(VP2==1)&&(VP3==1)))                            
	RCALL SUBOPT_0x2A
	BRNE _0x87
	RCALL SUBOPT_0x2B
	BRNE _0x87
	RCALL SUBOPT_0x2C
	BREQ _0x88
_0x87:
	RJMP _0x86
_0x88:
;     471                   {
;     472                   SP1(rampe accel);
;     473                   delay_ms(500);
	RCALL SUBOPT_0x2D
;     474                   SP2(rampe decel);
;     475                   }
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
;     476                  else
	RJMP _0x89
_0x86:
;     477                   {
;     478                   etat=erreur;
	RCALL SUBOPT_0x21
;     479                   };
_0x89:
;     480                 while (((PC2==0))||((PC1==0)))                                
_0x8A:
	RCALL SUBOPT_0x2E
	BREQ _0x8D
	LDD  R26,Y+54
	CPI  R26,LOW(0x0)
	BRNE _0x8C
_0x8D:
;     481                   {
;     482                   }
	RJMP _0x8A
_0x8C:
;     483                   PWM1(0);
	RCALL SUBOPT_0x12
;     484                   if (((PC2==1)))                        
	RCALL SUBOPT_0x2F
	BRNE _0x8F
;     485                    {
;     486                    etat=etage_2;
	RJMP _0xC1
;     487                    }
;     488                   else
_0x8F:
;     489                    {
;     490                    if (((PC1==1)))                        
	LDD  R26,Y+54
	CPI  R26,LOW(0x1)
	BRNE _0x91
;     491                    {
;     492                    etat=etage_1;
;     493                    }
;     494                   else
_0x91:
;     495                    {
;     496                    etat=erreur;
_0xC1:
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,60
	RCALL SUBOPT_0x30
;     497                    };
;     498                    };
;     499                  }
	RJMP _0x7E
;     500       break;
;     501       case ML : PWM(0);
_0x7D:
	RCALL __CPD10
	BREQ PC+2
	RJMP _0x93
	RCALL SUBOPT_0x31
;     502                 while ((1))                     
;     503                  {
;     504                 while (((PO1==0))||((PO2==0))||((PO3==0)))                        
_0x97:
	RCALL SUBOPT_0x27
	BREQ _0x9A
	RCALL SUBOPT_0x28
	BREQ _0x9A
	RCALL SUBOPT_0x29
	BRNE _0x99
_0x9A:
;     505                  {
;     506                  }
	RJMP _0x97
_0x99:
;     507                  if (((VP1==1)&&(VP2==1)&&(VP3==1)))                            
	RCALL SUBOPT_0x2A
	BRNE _0x9D
	RCALL SUBOPT_0x2B
	BRNE _0x9D
	RCALL SUBOPT_0x2C
	BREQ _0x9E
_0x9D:
	RJMP _0x9C
_0x9E:
;     508                   {
;     509                   SP1(rampe accel);
;     510                   delay_ms(1000);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0xB
;     511                   SP2(rampe decel);
;     512                   }
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
;     513                  else
	RJMP _0x9F
_0x9C:
;     514                   {
;     515                   etat=erreur;
	RCALL SUBOPT_0x21
;     516                   };
_0x9F:
;     517                 while (((PC2==0))||((PC3==0)))                                
_0xA0:
	RCALL SUBOPT_0x2E
	BREQ _0xA3
	LDD  R26,Y+52
