
;CodeVisionAVR C Compiler V1.24.8a Evaluation
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : AT90S8535
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME AT90S8535
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0x30
	.EQU __sm_powerdown=0x20

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "asc.vec"
	.INCLUDE "asc.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Light
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Ascenseur 2006/2007
;      10 Version : 0.2
;      11 Date    : 19/02/2007
;      12 Author  : TOUZET / PETITJEAN / MOREUX
;      13 Company : Lycee Pierre-Emile MARTIN
;      14 Comments: 
;      15 Programme PPE Ascenseur
;      16 2006 / 2007
;      17 
;      18 
;      19 Chip type           : AT90S8535
;      20 Clock frequency     : 4,000000 MHz
;      21 Memory model        : Small
;      22 External SRAM size  : 0
;      23 Data Stack size     : 128
;      24 *********************************************/
;      25 
;      26 // Chargement des librairies
;      27 #include <90s8535.h>    // librairie C ATMEL AT90S8535
;      28 #include <delay.h>      // Fonction delai
;      29 //#include <tpavnum.h> 	// Table de transcodage du clavier numrique utilis
;      30 #include <ssi.h> 	// SP de dcodage de la trame issue du clavier PS2 et SP Afficheur LCD
;      31 //#include <pavenum.h>    // Gestion d'un clavier numrique type PS2
;      32 #include <stdio.h>	// Fonctions standard entres / sorties
;      33 
;      34 // I2C Bus functions
;      35 #asm
;      36    .equ __i2c_port=0x12
   .equ __i2c_port=0x12
;      37    .equ __sda_bit=3
   .equ __sda_bit=3
;      38    .equ __scl_bit=7
   .equ __scl_bit=7
;      39 #endasm
;      40 #include <i2c.h>
;      41 
;      42 // Afficheur LCD
;      43 #asm
;      44    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      45 #endasm
;      46 #include <lcd.h>
;      47 #include <ascl.h>

	.CSEG
_Rampe_accel:
	ST   -Y,R16
;	mouvement -> Y+1
;	I -> R16
	LDI  R16,0
_0x4:
	SUBI R16,-LOW(10)
	RCALL SUBOPT_0x0
	BRNE _0x6
	RCALL SUBOPT_0x1
	RJMP _0x7
_0x6:
	RCALL SUBOPT_0x2
_0x7:
	CPI  R16,255
	BRLO _0x4
	RCALL SUBOPT_0x3
	RJMP _0x72
_Rampe_decel:
	ST   -Y,R16
;	mouvement -> Y+1
;	J -> R16
	LDI  R16,255
_0x9:
	SUBI R16,LOW(10)
	RCALL SUBOPT_0x0
	BRNE _0xB
	RCALL SUBOPT_0x1
	RJMP _0xC
_0xB:
	RCALL SUBOPT_0x2
_0xC:
	CPI  R16,50
	BRSH _0x9
	RCALL SUBOPT_0x3
	RJMP _0x72
_Ecrire_PCF8574:
;	add -> Y+1
;	valeur -> Y+0
	RCALL SUBOPT_0x4
	ORI  R30,0x40
	RCALL SUBOPT_0x5
	LD   R30,Y
	RCALL SUBOPT_0x5
	RCALL _i2c_stop
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x6
_0x72:
	ADIW R28,2
	RET
_LED1_egal_1:
	ST   -Y,R16
;	EtatPORTD -> R16
	ORI  R16,LOW(16)
	RCALL SUBOPT_0x7
	RJMP _0x71
_LED1_egal_0:
	ST   -Y,R16
;	EtatPORTD -> R16
	ANDI R16,LOW(239)
	RCALL SUBOPT_0x7
	RJMP _0x71
_LED2_egal_1:
	ST   -Y,R16
;	EtatPORTD -> R16
	ORI  R16,LOW(32)
	RCALL SUBOPT_0x7
	RJMP _0x71
_LED2_egal_0:
	ST   -Y,R16
;	EtatPORTD -> R16
	ANDI R16,LOW(223)
	RCALL SUBOPT_0x7
	RJMP _0x71
_LED3_egal_1:
	ST   -Y,R16
;	EtatPORTD -> R16
	ORI  R16,LOW(64)
	RCALL SUBOPT_0x7
	RJMP _0x71
_LED3_egal_0:
	ST   -Y,R16
;	EtatPORTD -> R16
	ANDI R16,LOW(191)
	RCALL SUBOPT_0x7
	RJMP _0x71
_EL1_egal_1:
	ST   -Y,R16
;	EtatPORTD -> R16
	ORI  R16,LOW(2)
	RCALL SUBOPT_0x7
	RJMP _0x71
;	EtatPORTD -> R16
_EL2_egal_1:
	ST   -Y,R16
;	EtatPORTD -> R16
	ORI  R16,LOW(4)
	RCALL SUBOPT_0x7
	RJMP _0x71
;	EtatPORTD -> R16
_EL3_egal_1:
	ST   -Y,R16
;	EtatPORTD -> R16
	ORI  R16,LOW(8)
	RCALL SUBOPT_0x7
	RJMP _0x71
;	EtatPORTD -> R16
_DEF_egal_1:
	ST   -Y,R16
;	EtatPORTD -> R16
	ORI  R16,LOW(1)
	RCALL SUBOPT_0x7
	RJMP _0x71
_DEF_egal_0:
	ST   -Y,R16
;	EtatPORTD -> R16
	ANDI R16,LOW(254)
	RCALL SUBOPT_0x7
_0x71:
	LD   R16,Y+
	RET
_init_CGRAM:
	RCALL __SAVELOCR2
;	valeur -> Y+2
;	i -> R16
;	j -> R17
	RCALL SUBOPT_0x8
_0xE:
	CPI  R16,8
	BRSH _0xF
	RCALL SUBOPT_0x9
_0x11:
	CPI  R17,8
	BRSH _0x12
	ST   -Y,R16
	MOV  R30,R16
	LDI  R31,0
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	RCALL _lcd_write_byte
	SUBI R17,-1
	RJMP _0x11
_0x12:
	SUBI R16,-1
	RJMP _0xE
_0xF:
	RCALL __LOADLOCR2
	ADIW R28,4
	RET
;      48 
;      49 /*--------------------------------------------------------------------------------------------------------------------------
;      50 type 			Dsignation				      Commentaires		       
;      51 ----------------------------------------------------------------------------------------------------------------------------*/ 
;      52 char display_buffer_ligne0[17]; 	   // tampon ligne 0 de l'afficheur

	.DSEG
_display_buffer_ligne0:
	.BYTE 0x11
;      53 char display_buffer_ligne1[17]; 	   // tampon ligne 1 de l'afficheur
_display_buffer_ligne1:
	.BYTE 0x11
;      54 char display_buffer_ligne2[17]; 	   // tampon ligne 2 de l'afficheur
_display_buffer_ligne2:
	.BYTE 0x11
;      55 char display_buffer_ligne3[17]; 	   // tampon ligne 3 de l'afficheur
_display_buffer_ligne3:
	.BYTE 0x11
;      56 unsigned char EL1, EL2, EL3;		   // Etat d
;      57 
;      58 // Programme d'interruption
;      59 interrupt [EXT_INT0] void ext_int0_isr(void)
;      60 {

	.CSEG
_ext_int0_isr:
;      61 
;      62 //interrption INT0
;      63 
;      64 }
	RETI
;      65  
;      66 // Adresse CGRAM de l'afficheur LCD
;      67 #define Add_Caract0_CGRAM 0x40             //caractre 0
;      68 #define Add_Caract1_CGRAM 0x48		   //caractre 1
;      69 #define Add_Caract2_CGRAM 0x50             //caractre 2
;      70 #define Add_Caract3_CGRAM 0x58             //caractre 3
;      71 #define Add_Caract4_CGRAM 0x60             //caractre 4
;      72 #define Add_Caract5_CGRAM 0x68             //caractre 5
;      73 #define Add_Caract6_CGRAM 0x70             //caractre 6
;      74 #define Add_Caract7_CGRAM 0x78             //caractre 7
;      75 
;      76 // Adresses des Ports I2C
;      77 #define AD_BASE_PCF8574		0x40       // base I2C
;      78 #define AD_I2C_PORTA		0          // port A
;      79 #define AD_I2C_PORTB		1          // port B
;      80 #define AD_I2C_PORTC		2	   // port C
;      81 #define AD_I2C_PORTD		3          // port D
;      82 
;      83 // Adresses des ports I2C
;      84 #define I2C_PORTA 0
;      85 #define I2C_PORTB 1
;      86 #define I2C_PORTC 2
;      87 #define I2C_PORTD 3
;      88 
;      89 // Etat du graphe
;      90 #define etage_1	  0
;      91 #define	etage_2	  1
;      92 #define etage_3   2
;      93 #define monter	  3
;      94 #define descendre 4
;      95 #define erreur    5
;      96 
;      97 // Prototype des fonctions :
;      98 void Rampe_accel(unsigned char);
;      99 void Rampe_decel(unsigned char);
;     100 void Ecrire_PCF8574(unsigned char add, unsigned char valeur);
;     101 void LED1_egal_1();
;     102 void LED1_egal_0();
;     103 void LED2_egal_1();
;     104 void LED2_egal_0();
;     105 void LED3_egal_1();
;     106 void LED3_egal_0();
;     107 void EL1_egal_1();
;     108 void EL1_egal_0();
;     109 void EL2_egal_1();
;     110 void EL2_egal_0();
;     111 void EL3_egal_1();
;     112 void EL3_egal_0();
;     113 void DEF_egal_1();
;     114 void DEF_egal_0();
;     115 void init_CGRAM(char valeur[8][8]);
;     116 unsigned char Lire_PCF8574(unsigned char add);
;     117 
;     118 // Caractres personnaliss placs dans la mmoire CGRAM du LCD
;     119 
;     120 
;     121 // Caractre n1 : ATTENTION :
;     122 //---------------------------
;     123 const unsigned char attention[8][8] = {
;     124 {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01}, // @0 CGRAM
;     125 {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01},        // @1 CGRAM
;     126 {0x02, 0x02, 0x04, 0x05, 0x09, 0x09, 0x11, 0x11},        // @2 CGRAM
;     127 {0x08, 0x08, 0x04, 0x14, 0x12, 0x12, 0x11, 0x11},        // @3 CGRAM
;     128 {0x01, 0x01, 0x02, 0x02, 0x04, 0x04, 0x08, 0x0f},        // @4 CGRAM
;     129 {0x01, 0x01, 0x01, 0x00, 0x01, 0x01, 0x00, 0x1f},        // @5 CGRAM
;     130 {0x10, 0x10, 0x10, 0x00, 0x10, 0x10, 0x00, 0x1f},        // @6 CGRAM
;     131 {0x10, 0x10, 0x08, 0x08, 0x04, 0x04, 0x02, 0x1e}};       // @7 CGRAM                
;     132 
;     133 
;     134 void main(void)
;     135 {
_main:
;     136 /*--------------------------------------------------------------------------------------------------------------
;     137 type 			Dsignation				      Commentaires		       
;     138 --------------------------------------------------------------------------------------------------------------*/
;     139 unsigned char etat,OCR1AL,OCR1BL;
;     140 unsigned char PO1,PO2,PO3;
;     141 unsigned char PC1,PC2,PC3;
;     142 unsigned char AP1,AP2,AP3;
;     143 unsigned char AC1,AC2,AC3;
;     144 unsigned char VP1,VP2,VP3;
;     145 unsigned char coef;
;     146 unsigned char EtatPORTA,EtatPORTB,EtatPORTC,EtatPORTD;        
;     147 
;     148 
;     149 // Input/Output Ports initialization
;     150 // Port A initialization
;     151 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     152 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     153 PORTA=0x00;
	SBIW R28,17
;	etat -> R16
;	OCR1AL -> R17
;	OCR1BL -> R18
;	PO1 -> R19
;	PO2 -> R20
;	PO3 -> R21
;	PC1 -> Y+16
;	PC2 -> Y+15
;	PC3 -> Y+14
;	AP1 -> Y+13
;	AP2 -> Y+12
;	AP3 -> Y+11
;	AC1 -> Y+10
;	AC2 -> Y+9
;	AC3 -> Y+8
;	VP1 -> Y+7
;	VP2 -> Y+6
;	VP3 -> Y+5
;	coef -> Y+4
;	EtatPORTA -> Y+3
;	EtatPORTB -> Y+2
;	EtatPORTC -> Y+1
;	EtatPORTD -> Y+0
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     154 DDRA=0x00;
	OUT  0x1A,R30
;     155 
;     156 // Port B initialization
;     157 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     158 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     159 PORTB=0x00;
	OUT  0x18,R30
;     160 DDRB=0x00;
	OUT  0x17,R30
;     161 
;     162 // Port C initialization
;     163 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     164 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     165 PORTC=0x00;
	OUT  0x15,R30
;     166 DDRC=0x00;
	OUT  0x14,R30
;     167 
;     168 // Port D initialization
;     169 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
;     170 // State0=0 State1=0 State2=0 State3=0 State4=0 State5=0 State6=0 State7=0 
;     171 PORTD=0x00;
	OUT  0x12,R30
;     172 DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     173 
;     174 // Timer/Counter 0 initialization
;     175 // Clock source: System Clock
;     176 // Clock value: Timer 0 Stopped
;     177 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     178 TCNT0=0x00;
	OUT  0x32,R30
;     179 
;     180 // Timer/Counter 1 initialization
;     181 // Clock source: System Clock
;     182 // Clock value: 15,625 kHz
;     183 // Mode: Ph. correct PWM top=00FFh
;     184 // OC1A output: Non-Inv.
;     185 // OC1B output: Non-Inv.
;     186 // Noise Canceler: Off
;     187 // Input Capture on Falling Edge
;     188 // Timer 1 Overflow Interrupt: Off
;     189 // Input Capture Interrupt: Off
;     190 // Compare A Match Interrupt: Off
;     191 // Compare B Match Interrupt: Off
;     192 TCCR1A=0xA1;
	LDI  R30,LOW(161)
	OUT  0x2F,R30
;     193 TCCR1B=0x04;
	LDI  R30,LOW(4)
	OUT  0x2E,R30
;     194 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     195 TCNT1L=0x00;
	OUT  0x2C,R30
;     196 OCR1AH=0x00;
	OUT  0x2B,R30
;     197 OCR1AL=0x00;
	RCALL SUBOPT_0x9
;     198 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
;     199 OCR1BL=0x00;
	RCALL SUBOPT_0xA
;     200 
;     201 // Timer/Counter 2 initialization
;     202 // Clock source: System Clock
;     203 // Clock value: Timer 2 Stopped
;     204 // Mode: Normal top=FFh
;     205 // OC2 output: Disconnected
;     206 ASSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x22,R30
;     207 TCCR2=0x00;
	OUT  0x25,R30
;     208 TCNT2=0x00;
	OUT  0x24,R30
;     209 OCR2=0x00;
	OUT  0x23,R30
;     210 
;     211 // External Interrupt(s) initialization
;     212 // INT0: On
;     213 // INT0 Mode: Rising Edge
;     214 // INT1: Off
;     215 GIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x3B,R30
;     216 MCUCR=0x03;
	LDI  R30,LOW(3)
	OUT  0x35,R30
;     217 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     218 
;     219 // Timer(s)/Counter(s) Interrupt(s) initialization
;     220 TIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x39,R30
;     221 
;     222 // Analog Comparator initialization
;     223 // Analog Comparator: Off
;     224 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     225 // Analog Comparator Output: Off
;     226 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     227 
;     228 // I2C Bus initialisation
;     229 i2c_init();
	RCALL _i2c_init
;     230 
;     231 // LCD module initialisation
;     232 lcd_init(20);        
	LDI  R30,LOW(20)
	ST   -Y,R30
	RCALL _lcd_init
;     233 
;     234 // Global enable interrupts
;     235 #asm("sei")
	sei
;     236 
;     237 // initialisation :
;     238 //----------------
;     239 
;     240 {
;     241 sprintf(display_buffer_ligne0,"   PPE ascenseur");
	RCALL SUBOPT_0xB
	__POINTW1FN _0,0
	RCALL SUBOPT_0xC
;     242 sprintf(display_buffer_ligne1,"    2006 / 2007");
	RCALL SUBOPT_0xD
	__POINTW1FN _0,17
	RCALL SUBOPT_0xC
;     243 sprintf(display_buffer_ligne2,"     Carte SSI");
	RCALL SUBOPT_0xE
	__POINTW1FN _0,33
	RCALL SUBOPT_0xC
;     244 sprintf(display_buffer_ligne3,"  Lyce P-E MARTIN");
	RCALL SUBOPT_0xF
	__POINTW1FN _0,48
	RCALL SUBOPT_0xC
;     245 //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     246 delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x6
;     247 
;     248 //faire descendre la cabine jusqu' l'tage 1 et faire clignoter les leds et afficher..
;     249 
;     250 while (PC1==0)                         
_0x13:
	LDD  R30,Y+16
	CPI  R30,0
	BRNE _0x15
;     251   {
;     252   sprintf(display_buffer_ligne0,"   Initialisation");
	RCALL SUBOPT_0xB
	__POINTW1FN _0,67
	RCALL SUBOPT_0xC
;     253   sprintf(display_buffer_ligne1,"        ----");
	RCALL SUBOPT_0xD
	__POINTW1FN _0,85
	RCALL SUBOPT_0xC
;     254   sprintf(display_buffer_ligne2," dplacement de la");
	RCALL SUBOPT_0xE
	__POINTW1FN _0,98
	RCALL SUBOPT_0xC
;     255   sprintf(display_buffer_ligne3,"cabine jusqu'au RDC");
	RCALL SUBOPT_0xF
	__POINTW1FN _0,117
	RCALL SUBOPT_0xC
;     256   //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     257   //OCR1AL=;              //  complter : lancer le moteur en descente
;     258   //OCR1BL=;              //  complter : lancer le moteur en descente
;     259   LED1_egal_1();
	RCALL _LED1_egal_1
;     260   LED2_egal_1();
	RCALL _LED2_egal_1
;     261   LED3_egal_1();
	RCALL _LED3_egal_1
;     262   DEF_egal_1();
	RCALL _DEF_egal_1
;     263   delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x6
;     264   LED1_egal_0();
	RCALL _LED1_egal_0
;     265   LED2_egal_0();
	RCALL _LED2_egal_0
;     266   LED3_egal_0();
	RCALL _LED3_egal_0
;     267   DEF_egal_0();
	RCALL _DEF_egal_0
;     268   }
	RJMP _0x13
_0x15:
;     269 OCR1AL=0;                // arrter le moteur
	RCALL SUBOPT_0x9
;     270 OCR1BL=0;                // arrter le moteur
	RCALL SUBOPT_0xA
;     271 etat=etage_1;
	RCALL SUBOPT_0x8
;     272 }
;     273 
;     274 //fin initialisation
;     275 
;     276 while (1)
_0x16:
;     277       {
;     278       switch (etat)
	MOV  R30,R16
;     279       {
;     280       case etage_1 : EL1_egal_1();
	CPI  R30,0
	BREQ PC+2
	RJMP _0x1C
	RCALL _EL1_egal_1
;     281                      LED1_egal_1();
	RCALL _LED1_egal_1
;     282                      sprintf(display_buffer_ligne0,"Etage 1");
	RCALL SUBOPT_0xB
	__POINTW1FN _0,137
	RCALL SUBOPT_0xC
;     283                      sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     284                      sprintf(display_buffer_ligne2,"attente appel");
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0xC
;     285                      sprintf(display_buffer_ligne3,"porte 1 deverouillee");
	RCALL SUBOPT_0xF
	__POINTW1FN _0,159
	RCALL SUBOPT_0xC
;     286                      //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     287                if ((AP2 == 1)||(AC2 == 1))
	RCALL SUBOPT_0x12
	BREQ _0x1E
	RCALL SUBOPT_0x13
	BRNE _0x1D
_0x1E:
;     288        	       	 {
;     289        	  	   do           //crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
_0x21:
;     290        	  	   {
;     291        	  	   sprintf(display_buffer_ligne0,"tage 2 demand");
	RCALL SUBOPT_0xB
	__POINTW1FN _0,180
	RCALL SUBOPT_0xC
;     292        	  	   sprintf(display_buffer_ligne1,"");       
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     293                    sprintf(display_buffer_ligne2,"fermer la porte !!");
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0xC
;     294                    sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     295        	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     296                    coef=1; 
	RCALL SUBOPT_0x15
;     297                    }
;     298                    while(PO1==1);
	RCALL SUBOPT_0x16
	BREQ _0x21
;     299                    etat=monter; 
	RCALL SUBOPT_0x17
;     300                  } 
;     301                     
;     302        	       	else if  ((AP3 == 1)||(AC3 == 1))
	RJMP _0x23
_0x1D:
	RCALL SUBOPT_0x18
	BREQ _0x25
	RCALL SUBOPT_0x19
	BRNE _0x24
_0x25:
;     303        	       	 {
;     304        	  	   do           //crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
_0x28:
;     305        	  	   {
;     306        	  	   sprintf(display_buffer_ligne0,"tage 3 demand");
	RCALL SUBOPT_0xB
	__POINTW1FN _0,215
	RCALL SUBOPT_0xC
;     307        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     308                    sprintf(display_buffer_ligne2,"fermer la porte !!");
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0xC
;     309        	           sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     310        	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     311                    coef=2;
	RCALL SUBOPT_0x1A
;     312                    }
;     313        	           while(PO1==1);
	RCALL SUBOPT_0x16
	BREQ _0x28
;     314        	           etat=monter;
	RCALL SUBOPT_0x17
;     315                  }
;     316                 else etat=etage_1;
	RJMP _0x2A
_0x24:
	RCALL SUBOPT_0x8
;     317                 LED1_egal_0();
_0x2A:
_0x23:
	RCALL _LED1_egal_0
;     318       break;
	RJMP _0x1B
;     319       
;     320       case etage_2 :  EL2_egal_1();
_0x1C:
	CPI  R30,LOW(0x1)
	BRNE _0x2B
	RCALL _EL2_egal_1
;     321                       LED2_egal_1();
	RCALL _LED2_egal_1
;     322                       sprintf(display_buffer_ligne0,"Etage 2");
	RCALL SUBOPT_0xB
	__POINTW1FN _0,231
	RCALL SUBOPT_0xC
;     323                       sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     324                       sprintf(display_buffer_ligne2,"attente appel");
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0xC
;     325                       sprintf(display_buffer_ligne3,"porte 2 deverouillee");
	RCALL SUBOPT_0xF
	__POINTW1FN _0,239
	RCALL SUBOPT_0xC
;     326                       //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     327                 if ((AP1 == 1)||(AC1 == 1))
	RCALL SUBOPT_0x1B
	BREQ _0x2D
	RCALL SUBOPT_0x1C
	BRNE _0x2C
_0x2D:
;     328                  {
;     329        	  	   do           //crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
_0x30:
;     330        	  	   {
;     331        	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0xC
;     332        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     333                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0xC
;     334        	           sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     335        	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     336                    coef=1; 
	RCALL SUBOPT_0x15
;     337                    }
;     338                    while(PO2==1); 
	RCALL SUBOPT_0x1F
	BREQ _0x30
;     339                    etat=descendre;
	RCALL SUBOPT_0x20
;     340                  }
;     341        	       	else if  ((AP3 == 1)||(AC3 == 1))
	RJMP _0x32
_0x2C:
	RCALL SUBOPT_0x18
	BREQ _0x34
	RCALL SUBOPT_0x19
	BRNE _0x33
_0x34:
;     342        	       	 {
;     343        	  	   do           //crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
_0x37:
;     344        	  	   {
;     345        	  	   sprintf(display_buffer_ligne0,"etage 3 demand");
	RCALL SUBOPT_0xB
	__POINTW1FN _0,294
	RCALL SUBOPT_0xC
;     346        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     347                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0xC
;     348        	           sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     349        	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     350                    coef=1;
	RCALL SUBOPT_0x15
;     351                    }   
;     352                    while(PO2==1);
	RCALL SUBOPT_0x1F
	BREQ _0x37
;     353                    etat=monter;
	RCALL SUBOPT_0x17
;     354                  }
;     355        	       	else etat=etage_2;
	RJMP _0x39
_0x33:
	RCALL SUBOPT_0x21
;     356        	       	LED2_egal_0();
_0x39:
_0x32:
	RCALL _LED2_egal_0
;     357       break; 
	RJMP _0x1B
;     358       
;     359       case etage_3 :  EL3_egal_1();
_0x2B:
	CPI  R30,LOW(0x2)
	BRNE _0x3A
	RCALL _EL3_egal_1
;     360                       LED3_egal_1();
	RCALL _LED3_egal_1
;     361                       sprintf(display_buffer_ligne0,"etage 3");
	RCALL SUBOPT_0xB
	__POINTW1FN _0,310
	RCALL SUBOPT_0xC
;     362                       sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     363                       sprintf(display_buffer_ligne2,"attente appel");
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0xC
;     364                       sprintf(display_buffer_ligne3,"porte 3 deverouillee");
	RCALL SUBOPT_0xF
	__POINTW1FN _0,318
	RCALL SUBOPT_0xC
;     365                       //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     366                 if ((AP1 == 1)||(AC1 == 1))
	RCALL SUBOPT_0x1B
	BREQ _0x3C
	RCALL SUBOPT_0x1C
	BRNE _0x3B
_0x3C:
;     367                  {
;     368        	  	   do           //crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
_0x3F:
;     369        	  	   {
;     370        	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0xC
;     371        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     372                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0xC
;     373        	           sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     374        	           //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     375                    coef=2; 
	RCALL SUBOPT_0x1A
;     376                    }
;     377                    while(PO3==1);
	RCALL SUBOPT_0x22
	BREQ _0x3F
;     378                    etat=descendre;
	RCALL SUBOPT_0x20
;     379                  }
;     380        	       	else if  ((AP2 == 1)||(AC2 == 1))
	RJMP _0x41
_0x3B:
	RCALL SUBOPT_0x12
	BREQ _0x43
	RCALL SUBOPT_0x13
	BRNE _0x42
_0x43:
;     381        	       	 {
;     382        	  	   do           //crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
_0x46:
;     383        	  	   {
;     384        	  	   sprintf(display_buffer_ligne0,"etage 2 demand");
	RCALL SUBOPT_0xB
	__POINTW1FN _0,339
	RCALL SUBOPT_0xC
;     385        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     386                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0xC
;     387        	           sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xC
;     388        	           //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     389                    coef=1;
	RCALL SUBOPT_0x15
;     390                    }
;     391        	           while(PO3==1);
	RCALL SUBOPT_0x22
	BREQ _0x46
;     392                    etat=descendre;
	RCALL SUBOPT_0x20
;     393                  }
;     394                  else etat=etage_3;
	RJMP _0x48
_0x42:
	RCALL SUBOPT_0x23
;     395                  LED3_egal_0();
_0x48:
_0x41:
	RCALL _LED3_egal_0
;     396       break; 
	RJMP _0x1B
;     397       
;     398       case monter : OCR1AL=0  ;      //  complter (moteur  l'arrt)
_0x3A:
	CPI  R30,LOW(0x3)
	BRNE _0x49
	RCALL SUBOPT_0x9
;     399                     OCR1BL=0  ;      //  complter
	RCALL SUBOPT_0xA
;     400                      while ((PO1==0)||(PO2==0)||(PO3==0));
_0x4A:
	CPI  R19,0
	BREQ _0x4D
	CPI  R20,0
	BREQ _0x4D
	CPI  R21,0
	BRNE _0x4C
_0x4D:
	RJMP _0x4A
_0x4C:
;     401                      if ((VP1==1)&&(VP2==1)&&(VP3==1))                            
	RCALL SUBOPT_0x24
	BRNE _0x50
	RCALL SUBOPT_0x25
	BRNE _0x50
	RCALL SUBOPT_0x26
	BREQ _0x51
_0x50:
	RJMP _0x4F
_0x51:
;     402                       {
;     403                       Rampe_accel(0);
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x28
;     404                       delay_ms(coef*500);
;     405                       Rampe_decel(0);
	RCALL SUBOPT_0x27
	RCALL _Rampe_decel
;     406                       }
;     407                      else
	RJMP _0x52
_0x4F:
;     408                       etat=erreur;
	RCALL SUBOPT_0x29
;     409                      while ((PC2==0)||(PC3==0));
_0x52:
_0x53:
	RCALL SUBOPT_0x2A
	BREQ _0x56
	LDD  R26,Y+14
	CPI  R26,LOW(0x0)
	BRNE _0x55
_0x56:
	RJMP _0x53
_0x55:
;     410                       OCR1AL=0  ;      //  complter (moteur  l'arrt)
	RCALL SUBOPT_0x9
;     411                       OCR1BL=0  ;      //  complter
	RCALL SUBOPT_0xA
;     412                      if (PC2==1)                        
	RCALL SUBOPT_0x2B
	BRNE _0x58
;     413                       etat=etage_2;
	RCALL SUBOPT_0x21
;     414                      else if (PC3==1)                        
	RJMP _0x59
_0x58:
	LDD  R26,Y+14
	CPI  R26,LOW(0x1)
	BRNE _0x5A
;     415                       etat=etage_3;
	RCALL SUBOPT_0x23
;     416                      else
	RJMP _0x5B
_0x5A:
;     417                       etat=erreur;
	RCALL SUBOPT_0x29
;     418       break; 
_0x5B:
_0x59:
	RJMP _0x1B
;     419       	
;     420       case descendre : OCR1AL=0  ;      //  complter (moteur  l'arrt)
_0x49:
	CPI  R30,LOW(0x4)
	BRNE _0x5C
	RCALL SUBOPT_0x9
;     421                        OCR1BL=0  ;      //  complter
	RCALL SUBOPT_0xA
;     422                         while ((PO1==0)||(PO2==0)||(PO3==0));
_0x5D:
	CPI  R19,0
	BREQ _0x60
	CPI  R20,0
	BREQ _0x60
	CPI  R21,0
	BRNE _0x5F
_0x60:
	RJMP _0x5D
_0x5F:
;     423                         if ((VP1==1)&&(VP2==1)&&(VP3==1))                            
	RCALL SUBOPT_0x24
	BRNE _0x63
	RCALL SUBOPT_0x25
	BRNE _0x63
	RCALL SUBOPT_0x26
	BREQ _0x64
_0x63:
	RJMP _0x62
_0x64:
;     424                          {
;     425                          Rampe_accel(1);
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x28
;     426                          delay_ms(coef*500);
;     427                          Rampe_decel(1);
	RCALL SUBOPT_0x2C
	RCALL _Rampe_decel
;     428                          }
;     429                         else
	RJMP _0x65
_0x62:
;     430                          etat=erreur;
	RCALL SUBOPT_0x29
;     431                         while ((PC2==0)||(PC1==0));
_0x65:
_0x66:
	RCALL SUBOPT_0x2A
	BREQ _0x69
	LDD  R26,Y+16
	CPI  R26,LOW(0x0)
	BRNE _0x68
_0x69:
	RJMP _0x66
_0x68:
;     432                         OCR1AL=0  ;      //  complter (arrter le moteur)
	RCALL SUBOPT_0x9
;     433                         OCR1BL=0  ;      //  complter
	RCALL SUBOPT_0xA
;     434                         if (PC2==1)                        
	RCALL SUBOPT_0x2B
	BRNE _0x6B
;     435                          etat=etage_2;
	RCALL SUBOPT_0x21
;     436                         else if (PC1==1)                        
	RJMP _0x6C
_0x6B:
	LDD  R26,Y+16
	CPI  R26,LOW(0x1)
	BRNE _0x6D
;     437                          etat=etage_1;
	RCALL SUBOPT_0x8
;     438                         else
	RJMP _0x6E
_0x6D:
;     439                          etat=erreur;
	RCALL SUBOPT_0x29
;     440       break;
_0x6E:
_0x6C:
	RJMP _0x1B
;     441       
;     442       case erreur : DEF_egal_1();
_0x5C:
	CPI  R30,LOW(0x5)
	BRNE _0x1B
	RCALL _DEF_egal_1
;     443                     init_CGRAM(attention);
	LDI  R30,LOW(_attention*2)
	LDI  R31,HIGH(_attention*2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _init_CGRAM
;     444                     lcd_gotoxy(17,0);		// caractre perso (ATTENTION) ligne 0
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x27
	RCALL _lcd_gotoxy
;     445 		    lcd_putchar(0);
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x2E
;     446 		    lcd_gotoxy(18,0);
	RCALL SUBOPT_0x27
	RCALL _lcd_gotoxy
;     447 		    lcd_putchar(1);
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2F
;     448 		    lcd_gotoxy(17,1);           // caractre perso (ATTENTION) ligne 1
	RCALL SUBOPT_0x2C
	RCALL _lcd_gotoxy
;     449 		    lcd_putchar(2);
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x2E
;     450 		    lcd_gotoxy(18,1);
	RCALL SUBOPT_0x2C
	RCALL _lcd_gotoxy
;     451 		    lcd_putchar(3);
	RCALL SUBOPT_0x31
	RCALL _lcd_putchar
;     452 		    lcd_gotoxy(16,2);           // caractre perso (ATTENTION) ligne 2
	LDI  R30,LOW(16)
	RCALL SUBOPT_0x32
	RCALL _lcd_gotoxy
;     453 		    lcd_putchar(4);
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL SUBOPT_0x2F
;     454 		    lcd_gotoxy(17,2);
	RCALL SUBOPT_0x30
	RCALL _lcd_gotoxy
;     455 		    lcd_putchar(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL SUBOPT_0x2E
;     456 		    lcd_gotoxy(18,2);
	RCALL SUBOPT_0x30
	RCALL _lcd_gotoxy
;     457 		    lcd_putchar(6);
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x33
;     458 		    lcd_gotoxy(19,2);
	LDI  R30,LOW(19)
	RCALL SUBOPT_0x32
	RCALL _lcd_gotoxy
;     459 		    lcd_putchar(7);
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x33
;     460       break;
;     461    }
_0x1B:
;     462   };
	RJMP _0x16
;     463 
;     464 AP1 = (Lire_PCF8574(I2C_PORTA)&0b01000000);        // lecture PA6
;     465 AP2 = (Lire_PCF8574(I2C_PORTA)&0b10000000);        // lecture PA7
;     466 AP3 = (Lire_PCF8574(I2C_PORTB)&0b00000001);        // lecture PB0
;     467 AC1 = (Lire_PCF8574(I2C_PORTB)&0b00000010);        // lecture PB1
;     468 AC2 = (Lire_PCF8574(I2C_PORTB)&0b00000100);        // lecture PB2
;     469 AC3 = (Lire_PCF8574(I2C_PORTB)&0b00001000);        // lecture PB3
;     470 PO1 = (Lire_PCF8574(I2C_PORTA)&0b00001000);        // lecture PA3
;     471 PO2 = (Lire_PCF8574(I2C_PORTA)&0b00010000);        // lecture PA4
;     472 PO3 = (Lire_PCF8574(I2C_PORTA)&0b00100000);        // lecture PA5
;     473 VP1 = (Lire_PCF8574(I2C_PORTC)&0b00000001);        // lecture PC0
;     474 VP2 = (Lire_PCF8574(I2C_PORTC)&0b00000010);        // lecture PC1
;     475 VP3 = (Lire_PCF8574(I2C_PORTC)&0b00000100);        // lecture PC2
;     476 PC1 = (Lire_PCF8574(I2C_PORTA)&0b00000001);        // lecture PA0
;     477 PC2 = (Lire_PCF8574(I2C_PORTA)&0b00000010);        // lecture PA1
;     478 PC3 = (Lire_PCF8574(I2C_PORTA)&0b00000100);        // lecture PA2
;     479 
;     480 
;     481  
;     482 
;     483 //ajouter la relecture de l'tat des sorties (EL1, EL2 et EL3) par scurit !!! addresses  revoir
;     484 
;     485 EL1 = (Lire_PCF8574(I2C_PORTD)&0b00000000);        // lecture PDx
;     486 EL2 = (Lire_PCF8574(I2C_PORTD)&0b00000000);        // lecture PDx
;     487 EL3 = (Lire_PCF8574(I2C_PORTD)&0b00000000);        // lecture PDx
;     488 
;     489 
;     490 
;     491 
;     492 EtatPORTA = (Lire_PCF8574(I2C_PORTA));           // lecture du port A
;     493 EtatPORTB = (Lire_PCF8574(I2C_PORTB));           // Lecture du port B
;     494 EtatPORTC = (Lire_PCF8574(I2C_PORTC));           // Lecture du port C
;     495 EtatPORTD = (Lire_PCF8574(I2C_PORTD));           // Lecture du port D
;     496                                         
;     497 
;     498 Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
;     499 }
_0x70:
	RJMP _0x70
;     500 
;     501 //fin du programme principal
;     502 
;     503 // Sous-programmes
;     504 //----------------
;     505     
;     506 unsigned char Lire_PCF8574(unsigned char add)          // Procdure de lecture du port I2C
;     507 {
_Lire_PCF8574:
;     508   unsigned char entrees;
;     509   i2c_start();
	ST   -Y,R16
;	add -> Y+1
;	entrees -> R16
	RCALL SUBOPT_0x4
;     510   i2c_write(0x41 | add << 1);
	ORI  R30,LOW(0x41)
	RCALL SUBOPT_0x5
;     511   entrees = i2c_read(0);
	RCALL SUBOPT_0x27
	RCALL _i2c_read
	MOV  R16,R30
;     512   i2c_stop();
	RCALL _i2c_stop
;     513   return entrees;    
	MOV  R30,R16
	RCALL SUBOPT_0x3
	ADIW R28,2
	RET
;     514 } 

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	LDD  R30,Y+1
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	OUT  0x2A,R16
	LDI  R30,LOW(0)
	OUT  0x28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(0)
	OUT  0x2A,R30
	OUT  0x28,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3:
	LDD  R16,Y+0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	RCALL _i2c_start
	LDD  R30,Y+1
	LSL  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x5:
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x7:
	IN   R30,0x12
	ST   -Y,R30
	ST   -Y,R16
	RJMP _Ecrire_PCF8574

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x8:
	LDI  R16,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x9:
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xA:
	LDI  R18,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0xB:
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 44 TIMES
SUBOPT_0xC:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0xD:
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(_display_buffer_ligne2)
	LDI  R31,HIGH(_display_buffer_ligne2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0xF:
	LDI  R30,LOW(_display_buffer_ligne3)
	LDI  R31,HIGH(_display_buffer_ligne3)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES
SUBOPT_0x10:
	__POINTW1FN _0,16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x11:
	__POINTW1FN _0,145
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	LDD  R26,Y+12
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	LDD  R26,Y+9
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	__POINTW1FN _0,196
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x15:
	LDI  R30,LOW(1)
	STD  Y+4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	CPI  R19,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x17:
	LDI  R16,LOW(3)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	LDD  R26,Y+11
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	LDD  R26,Y+8
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	LDI  R30,LOW(2)
	STD  Y+4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	LDD  R26,Y+13
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	LDD  R26,Y+10
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1D:
	__POINTW1FN _0,260
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x1E:
	__POINTW1FN _0,276
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1F:
	CPI  R20,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x20:
	LDI  R16,LOW(4)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x21:
	LDI  R16,LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x22:
	CPI  R21,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x23:
	LDI  R16,LOW(2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x24:
	LDD  R26,Y+7
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x26:
	LDD  R26,Y+5
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES
SUBOPT_0x27:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x28:
	RCALL _Rampe_accel
	LDD  R30,Y+4
	LDI  R31,0
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL __MULW12U
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x29:
	LDI  R16,LOW(5)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
