/* Librairire PPE Ascenseur 2006-2007
Auteur: MOREUX/PETITJEAN/TOUZET
Date De Cration: 02/04/2007
Date De Mise A Jour: 02/04/2007

Librairie adoptant les fonctions void ncssaire au bon fonctionnement de la Maquette*/
    
#ifndef_ascl_INCLUDED_
#define_ascl_INCLUDED_


#pragma used+
void Rampe_accel(unsigned char mouvement)           // Sous-programme rampe acceleration
    {
     unsigned char I=0;
     do
      {
      I=I+10;
      delay_ms(100);
      if (mouvement==0)
       {
       OCR1AL=I;
       OCR1BL=0;
       }
       else
       	{
       	OCR1AL=0;
       	OCR1BL=I;
       	}
      }
     while (I<255);
    }



void Rampe_decel(unsigned char mouvement)           // Sous-programme rampe deceleration
    {
     unsigned char J=255;
     do
      {
      J=J-10;
      delay_ms(100);
      if (mouvement==0)
       {
       OCR1AL=J;
       OCR1BL=0;
       }
       else
       	{
       	OCR1AL=0;
       	OCR1BL=J;
       	}
      }
     while (J>=50);
    }




void Ecrire_PCF8574(unsigned char add, unsigned char valeur)           // Procdure d'criture sur le port I2C
{
  i2c_start();
  i2c_write(0x40 | add << 1);
  i2c_write(valeur);
  i2c_stop();
  delay_ms(10);
} 





void LED1_egal_1()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD | 0b00010000;    //LED1=1
Ecrire_PCF8574(PORTD,EtatPORTD);     //LED1=1
}




void LED1_egal_0()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD & 0b11101111;    //LED1=0
Ecrire_PCF8574(PORTD,EtatPORTD);     //LED1=0
}





void LED2_egal_1()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD | 0b00100000;     //LED2=1
Ecrire_PCF8574(PORTD,EtatPORTD);      //LED2=1
}





void LED2_egal_0()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD & 0b11011111;     //LED2=0
Ecrire_PCF8574(PORTD,EtatPORTD);      //LED2=0
}




void LED3_egal_1()
{         
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD | 0b01000000;     //LED3=1
Ecrire_PCF8574(PORTD,EtatPORTD);      //LED3=1
}





void LED3_egal_0()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD & 0b10111111;     //LED3=0
Ecrire_PCF8574(PORTD,EtatPORTD);      //LED3=0
}

      



void EL1_egal_1()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD | 0b00000010;	//EL1=1 
Ecrire_PCF8574(PORTD,EtatPORTD); 	//EL1=1
}                                      





void EL1_egal_0()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD & 0b11111101;     // EL1=0
Ecrire_PCF8574(PORTD,EtatPORTD);      // EL1=0
}





void EL2_egal_1()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD | 0b00000100;     //EL2=1
Ecrire_PCF8574(PORTD,EtatPORTD);      //EL2=1
}




void EL2_egal_0()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD & 0b11111011;     //EL2=0
Ecrire_PCF8574(PORTD,EtatPORTD);      //EL2=0
}





void EL3_egal_1()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD | 0b00001000;      //EL3=1
Ecrire_PCF8574(PORTD,EtatPORTD);      //EL3=1
}





void EL3_egal_0()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD & 0b11110111;     //EL3=0
Ecrire_PCF8574(PORTD,EtatPORTD);      //EL3=1
}





void DEF_egal_1()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD | 0b00000001;     //DEF=1
Ecrire_PCF8574(PORTD,EtatPORTD);      //DEF=1
}




void DEF_egal_0()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD & 0b11111110;     //DEF=0
Ecrire_PCF8574(PORTD,EtatPORTD);      //DEF=0
}


 
void init_CGRAM(char valeur[8][8])
 {
 unsigned char i,j;
 for (i=0;i<8;i++)
  {
   for (j=0;j<8;j++)
   	lcd_write_byte(Add_Caract0_CGRAM + i, valeur[i][j]);
    }
 }

#pragma used-
#pragma library ascl.lib
#endif
  