
;CodeVisionAVR C Compiler V1.24.8a Evaluation
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : AT90S8535
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME AT90S8535
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0x30
	.EQU __sm_powerdown=0x20

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "T_IO_I2C.vec"
	.INCLUDE "T_IO_I2C.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : ES I2C
;      10 Version : 1
;      11 Date    : 29/11/2006
;      12 Author  : Philippe Mariano                
;      13 Company : LYCEE Pierre Emile MARTIN       
;      14 Comments: Test de la carte ES I2C
;      15 
;      16 
;      17 Chip type           : AT90S8535
;      18 Clock frequency     : 4,000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 128
;      22 *********************************************/
;      23 
;      24 #include <90s8535.h>
;      25 #include <ssi.h>      // contient les fonctions Lire_BP,Affiche_LCD
;      26 #include <delay.h>    // contient la fonction delay_ms
;      27 #include <stdio.h>    // contient la fonction sprintf
;      28 
;      29 // I2C Bus functions
;      30 #asm
;      31    .equ __i2c_port=0x12
   .equ __i2c_port=0x12
;      32    .equ __sda_bit=3
   .equ __sda_bit=3
;      33    .equ __scl_bit=7
   .equ __scl_bit=7
;      34 #endasm
;      35 #include <i2c.h>
;      36 
;      37 // Alphanumeric LCD Module functions
;      38 #asm
;      39    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      40 #endasm
;      41 #include <lcd.h>
;      42 
;      43 // Adresses des Ports I2C
;      44 #define AD_BASE_PCF8574		0x40
;      45 #define AD_I2C_PORTA		0
;      46 #define AD_I2C_PORTB		1
;      47 #define AD_I2C_PORTC		2
;      48 #define AD_I2C_PORTD		3
;      49 
;      50 // Declare your global variables here
;      51 /*-----------------------------------------------------------------------------------------
;      52 type 		nom 				       		dsignation       
;      53 ------------------------------------------------------------------------------------------*/
;      54 char display_buffer_ligne0[21]; 			// tampon ligne 0 de l'afficheur
_display_buffer_ligne0:
	.BYTE 0x15
;      55 char display_buffer_ligne1[21]; 	       		// tampon ligne 1 de l'afficheur
_display_buffer_ligne1:
	.BYTE 0x15
;      56 char display_buffer_ligne2[21]; 			// tampon ligne 2 de l'afficheur
_display_buffer_ligne2:
	.BYTE 0x15
;      57 char display_buffer_ligne3[21]; 	       		// tampon ligne 3 de l'afficheur
_display_buffer_ligne3:
	.BYTE 0x15
;      58 enum Etat_Test {LECTURE_I2C_PORTA,LECTURE_I2C_PORTB,LECTURE_I2C_PORTC, ECRITURE_I2C_PORTD,
;      59  SAISIE_VALEUR, ENVOI_VALEUR} etat=LECTURE_I2C_PORTA, etat_1=LECTURE_I2C_PORTB;                 // Etats du graphe tests
;      60 
;      61 // Constantes
;      62 const char MENU_E[]="INC>Suiv DEC>PRE"; 

	.CSEG
;      63 
;      64 
;      65 // Prototype des fonctions
;      66 //-------------------------
;      67 unsigned char Lire_PCF8574(unsigned char add);
;      68 unsigned char Ecrire_valeur(unsigned char x, unsigned char y);
;      69 void Ecrire_PCF8574(unsigned char add, unsigned char valeur_portD);
;      70 //-----------------------
;      71 // Programme principal
;      72 //-----------------------
;      73 
;      74 void main(void)
;      75 {   // dbut prog
_main:
;      76 // Declare your local variables here
;      77 // -----------------------------------------------------------------------------------------
;      78 //type 		nom 					Commentaires  
;      79 // -------------------------------------------------------------------------------------- --
;      80 unsigned char entrees_A=0, entrees_1_A = 1;	// reoit l'tat du PORT A sur l'I2C
;      81 unsigned char entrees_B=0, entrees_1_B = 1;	// reoit l'tat du PORT B sur l'I2C
;      82 unsigned char entrees_C=0, entrees_1_C = 1;	// reoit l'tat du PORT C sur l'I2C
;      83 unsigned char valeur_portD=0;			// contient la valeur  envoyer sur le PORT D
;      84 unsigned char BP;                               // contient le code du BP appuy (voir SSI.h)
;      85 
;      86 PORTA=0x3F;
	SBIW R28,2
	LDI  R24,1
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	LDI  R30,LOW(_0x4*2)
	LDI  R31,HIGH(_0x4*2)
	RCALL __INITLOCB
;	entrees_A -> R16
;	entrees_1_A -> R17
;	entrees_B -> R18
;	entrees_1_B -> R19
;	entrees_C -> R20
;	entrees_1_C -> R21
;	valeur_portD -> Y+1
;	BP -> Y+0
	RCALL SUBOPT_0x0
	LDI  R17,1
	LDI  R18,0
	LDI  R19,1
	RCALL SUBOPT_0x1
	LDI  R21,1
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;      87 DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;      88 
;      89 PORTB=0x00;
	OUT  0x18,R30
;      90 DDRB=0x3F;
	LDI  R30,LOW(63)
	OUT  0x17,R30
;      91 
;      92 // I2C Bus initialization
;      93 i2c_init();
	RCALL _i2c_init
;      94 
;      95 // LCD module initialization
;      96 lcd_init(20);
	LDI  R30,LOW(20)
	ST   -Y,R30
	RCALL _lcd_init
;      97 
;      98 
;      99 sprintf(display_buffer_ligne0,"Test de la carte");
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x3
;     100 sprintf(display_buffer_ligne1,"****E_S_I2C*****");
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
;     101 sprintf(display_buffer_ligne2,"Test de la carte");
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x3
;     102 sprintf(display_buffer_ligne3,"****E_S_I2C*****");
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x5
;     103 Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD440
;     104 delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RCALL SUBOPT_0x8
;     105 
;     106 
;     107 while (1)
_0x5:
;     108       {		   // Dbut While(1)  
;     109        
;     110       BP = Lire_BP();
	RCALL _Lire_BP
	ST   Y,R30
;     111       entrees_A = Lire_PCF8574(0);
	RCALL SUBOPT_0x9
	RCALL _Lire_PCF8574
	MOV  R16,R30
;     112       entrees_B = Lire_PCF8574(1);
	RCALL SUBOPT_0xA
	RCALL _Lire_PCF8574
	MOV  R18,R30
;     113       entrees_C = Lire_PCF8574(2);
	RCALL SUBOPT_0xB
	RCALL _Lire_PCF8574
	MOV  R20,R30
;     114       
;     115       switch (etat)
	MOV  R30,R4
;     116        {               // Dbut switch (etat)
;     117         case LECTURE_I2C_PORTA :   if ((etat_1 != etat) || (entrees_A != entrees_1_A))
	CPI  R30,0
	BRNE _0xB
	RCALL SUBOPT_0xC
	BRNE _0xD
	RCALL SUBOPT_0xD
	BREQ _0xC
_0xD:
;     118                         { 
;     119                          sprintf(display_buffer_ligne0,"[E] PORTA = 0x%-x",entrees_A);
	RCALL SUBOPT_0x2
	__POINTW1FN _0,34
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	RCALL SUBOPT_0xE
;     120                          sprintf(display_buffer_ligne1,MENU_E);
	RCALL SUBOPT_0xF
;     121                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x4
	RCALL _Affiche_LCD
;     122                          entrees_1_A = entrees_A;
	MOV  R17,R16
;     123                         } 
;     124         		if (BP == INC) etat = LECTURE_I2C_PORTB;
_0xC:
	RCALL SUBOPT_0x10
	BRNE _0xF
	LDI  R30,LOW(1)
	MOV  R4,R30
;     125        		       	       	else if (BP==DEC) etat = ECRITURE_I2C_PORTD;
	RJMP _0x10
_0xF:
	RCALL SUBOPT_0x11
	BRNE _0x11
	RCALL SUBOPT_0x12
;     126        			       			else etat = LECTURE_I2C_PORTA;
	RJMP _0x12
_0x11:
	CLR  R4
;     127        			etat_1 = LECTURE_I2C_PORTA; 
_0x12:
_0x10:
	CLR  R5
;     128        		        
;     129         break;
	RJMP _0xA
;     130         
;     131         case LECTURE_I2C_PORTB :   if ((etat_1 != etat) || (entrees_B != entrees_1_B))
_0xB:
	CPI  R30,LOW(0x1)
	BRNE _0x13
	RCALL SUBOPT_0xC
	BRNE _0x15
	CP   R19,R18
	BREQ _0x14
_0x15:
;     132                         { 
;     133                          sprintf(display_buffer_ligne0,"[E] PORTB = 0x%-x",entrees_B);
	RCALL SUBOPT_0x2
	__POINTW1FN _0,52
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R18
	RCALL SUBOPT_0xE
;     134                          sprintf(display_buffer_ligne1,MENU_E);
	RCALL SUBOPT_0xF
;     135                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x4
	RCALL _Affiche_LCD
;     136                          entrees_1_B = entrees_B;
	MOV  R19,R18
;     137                         } 
;     138         		if (BP == INC) etat = LECTURE_I2C_PORTC;
_0x14:
	RCALL SUBOPT_0x10
	BRNE _0x17
	LDI  R30,LOW(2)
	RJMP _0xD5
;     139        		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTA;
_0x17:
	RCALL SUBOPT_0x11
	BRNE _0x19
	CLR  R4
;     140        			       			else etat = LECTURE_I2C_PORTB;
	RJMP _0x1A
_0x19:
	LDI  R30,LOW(1)
_0xD5:
	MOV  R4,R30
;     141        			etat_1 = LECTURE_I2C_PORTB; 
_0x1A:
	LDI  R30,LOW(1)
	RJMP _0xD6
;     142        		        
;     143         break;
;     144         
;     145         case LECTURE_I2C_PORTC :   if ((etat_1 != etat) || (entrees_C != entrees_1_C))
_0x13:
	CPI  R30,LOW(0x2)
	BRNE _0x1B
	RCALL SUBOPT_0xC
	BRNE _0x1D
	CP   R21,R20
	BREQ _0x1C
_0x1D:
;     146                         { 
;     147                          sprintf(display_buffer_ligne0,"[E] PORTC = 0x%-x",entrees_C);
	RCALL SUBOPT_0x2
	__POINTW1FN _0,70
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R20
	RCALL SUBOPT_0xE
;     148                          sprintf(display_buffer_ligne1,MENU_E);
	RCALL SUBOPT_0xF
;     149                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x4
	RCALL _Affiche_LCD
;     150                          entrees_1_C = entrees_C;
	MOV  R21,R20
;     151                         } 
;     152         		if (BP == INC) etat = ECRITURE_I2C_PORTD;
_0x1C:
	RCALL SUBOPT_0x10
	BRNE _0x1F
	LDI  R30,LOW(3)
	RJMP _0xD7
;     153        		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTB;
_0x1F:
	RCALL SUBOPT_0x11
	BRNE _0x21
	LDI  R30,LOW(1)
	RJMP _0xD7
;     154        			       			else etat = LECTURE_I2C_PORTC;
_0x21:
	LDI  R30,LOW(2)
_0xD7:
	MOV  R4,R30
;     155        			etat_1 = LECTURE_I2C_PORTC; 
	LDI  R30,LOW(2)
	RJMP _0xD6
;     156        		        
;     157         break; 
;     158         
;     159         case ECRITURE_I2C_PORTD :   if (etat_1 != etat) 
_0x1B:
	CPI  R30,LOW(0x3)
	BRNE _0x23
	RCALL SUBOPT_0xC
	BREQ _0x24
;     160                         { 
;     161                          sprintf(display_buffer_ligne0,"[S]Val=%-x OK>rgl",valeur_portD);
	RCALL SUBOPT_0x2
	__POINTW1FN _0,88
	RCALL SUBOPT_0x13
;     162                          sprintf(display_buffer_ligne1,"SET>envoi val.  ");
	__POINTW1FN _0,106
	RCALL SUBOPT_0x14
;     163                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x4
	RCALL _Affiche_LCD
;     164                          }
;     165         		if (BP == INC) etat = LECTURE_I2C_PORTA;
_0x24:
	RCALL SUBOPT_0x10
	BRNE _0x25
	CLR  R4
;     166        		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTC;
	RJMP _0x26
_0x25:
	RCALL SUBOPT_0x11
	BRNE _0x27
	LDI  R30,LOW(2)
	RJMP _0xD8
;     167        		       	       	                   else if (BP==OK) etat = SAISIE_VALEUR;
_0x27:
	RCALL SUBOPT_0x15
	BRNE _0x29
	LDI  R30,LOW(4)
	RJMP _0xD8
;     168        		       	       	                   		else if (BP==SET) etat = ENVOI_VALEUR;
_0x29:
	LD   R26,Y
	CPI  R26,LOW(0x3D)
	BRNE _0x2B
	LDI  R30,LOW(5)
	RJMP _0xD8
;     169        			       						else etat = ECRITURE_I2C_PORTD;
_0x2B:
	LDI  R30,LOW(3)
_0xD8:
	MOV  R4,R30
;     170        			etat_1 = ECRITURE_I2C_PORTD; 
_0x26:
	LDI  R30,LOW(3)
	RJMP _0xD6
;     171        			
;     172        		        
;     173         break; 
;     174        
;     175         case SAISIE_VALEUR :   
_0x23:
	CPI  R30,LOW(0x4)
	BRNE _0x2D
;     176                          sprintf(display_buffer_ligne0,"0x%-u  INC>+ DEC>-",valeur_portD);
	RCALL SUBOPT_0x2
	__POINTW1FN _0,123
	RCALL SUBOPT_0x13
;     177                          sprintf(display_buffer_ligne1,"OK>suiv ENTR>srt"); 
	__POINTW1FN _0,142
	RCALL SUBOPT_0x14
;     178                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL _Affiche_LCD
;     179                          valeur_portD = Ecrire_valeur(2,0); 
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x9
	RCALL _Ecrire_valeur
	STD  Y+1,R30
;     180                          etat_1 = SAISIE_VALEUR;
	LDI  R30,LOW(4)
	MOV  R5,R30
;     181                          etat = ECRITURE_I2C_PORTD;
	RCALL SUBOPT_0x12
;     182         break;
	RJMP _0xA
;     183         
;     184         case ENVOI_VALEUR : if (etat_1 != etat)
_0x2D:
	CPI  R30,LOW(0x5)
	BRNE _0xA
	RCALL SUBOPT_0xC
	BREQ _0x2F
;     185         		{  
;     186                          sprintf(display_buffer_ligne0,"[S] PORTD = 0x%-x",valeur_portD);
	RCALL SUBOPT_0x2
	__POINTW1FN _0,159
	RCALL SUBOPT_0x13
;     187                          sprintf(display_buffer_ligne1,"OK>rgl INC DEC");
	__POINTW1FN _0,177
	RCALL SUBOPT_0x14
;     188                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL _Affiche_LCD
;     189                          Ecrire_PCF8574(AD_I2C_PORTD,valeur_portD);  
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
	RCALL _Ecrire_PCF8574
;     190           		}
;     191                          if (BP == INC) etat = LECTURE_I2C_PORTA;
_0x2F:
	RCALL SUBOPT_0x10
	BRNE _0x30
	CLR  R4
;     192        		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTC;
	RJMP _0x31
_0x30:
	RCALL SUBOPT_0x11
	BRNE _0x32
	LDI  R30,LOW(2)
	RJMP _0xD9
;     193        		       	       	                   else if (BP==OK) etat = ECRITURE_I2C_PORTD; 
_0x32:
	RCALL SUBOPT_0x15
	BRNE _0x34
	LDI  R30,LOW(3)
	RJMP _0xD9
;     194        		       	       	                   		else etat = ENVOI_VALEUR;
_0x34:
	LDI  R30,LOW(5)
_0xD9:
	MOV  R4,R30
;     195        			 etat_1 = ENVOI_VALEUR;
_0x31:
	LDI  R30,LOW(5)
_0xD6:
	MOV  R5,R30
;     196         break;
;     197         
;     198         } //fin du switch
_0xA:
;     199       } // fin du while
	RJMP _0x5
;     200 } // fin prog
_0x36:
	RJMP _0x36
;     201 
;     202 unsigned char Lire_PCF8574(unsigned char add)
;     203 {
_Lire_PCF8574:
;     204   unsigned char entrees;
;     205   i2c_start();
	ST   -Y,R16
;	add -> Y+1
;	entrees -> R16
	RCALL SUBOPT_0x18
;     206   i2c_write(0x41 | add << 1);
	ORI  R30,LOW(0x41)
	RCALL SUBOPT_0x19
;     207   entrees = i2c_read(0);
	RCALL SUBOPT_0x9
	RCALL _i2c_read
	MOV  R16,R30
;     208   i2c_stop();
	RCALL _i2c_stop
;     209   return entrees;    
	MOV  R30,R16
	RCALL SUBOPT_0x1A
	RJMP _0xD4
;     210 } 
;     211 
;     212 void Ecrire_PCF8574(unsigned char add, unsigned char valeur_portD)
;     213 {
_Ecrire_PCF8574:
;     214   i2c_start();
;	add -> Y+1
;	valeur_portD -> Y+0
	RCALL SUBOPT_0x18
;     215   i2c_write(0x40 | add << 1);
	ORI  R30,0x40
	RCALL SUBOPT_0x19
;     216   i2c_write(valeur_portD);
	LD   R30,Y
	RCALL SUBOPT_0x19
;     217   i2c_stop();
	RCALL _i2c_stop
;     218   delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x8
;     219 }
_0xD4:
	ADIW R28,2
	RET
;     220 
;     221 unsigned char Ecrire_valeur(unsigned char x, unsigned char y)
;     222 {    
_Ecrire_valeur:
;     223  unsigned char BP, etat=0, etat_1=1; 
;     224  int dizaines=0, dizaines_1 = 1, unites = 0, unites_1 = 1;
;     225  unsigned char Table_aff[16] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
;     226  
;     227  _lcd_write_data(displayOff3);
	SBIW R28,22
	LDI  R24,22
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x37*2)
	LDI  R31,HIGH(_0x37*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR5
;	x -> Y+28
;	y -> Y+27
;	BP -> R16
;	etat -> R17
;	etat_1 -> R18
;	dizaines -> R19,R20
;	dizaines_1 -> Y+25
;	unites -> Y+23
;	unites_1 -> Y+21
;	Table_aff -> Y+5
	LDI  R17,0
	LDI  R18,1
	LDI  R19,0
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1B
;     228  
;     229  while(1)
_0x38:
;     230   {
;     231    BP = Lire_BP();
	RCALL _Lire_BP
	MOV  R16,R30
;     232    switch (etat)
	MOV  R30,R17
;     233 	{
;     234 	  case 0 : // Rglage des dizaines
	CPI  R30,0
	BRNE _0x3E
;     235                    if (dizaines==-1) dizaines = 15;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	CP   R30,R19
	CPC  R31,R20
	BRNE _0x3F
	__GETWRN 19,20,15
;     236         		else if (dizaines == 16) dizaines = 0;
	RJMP _0x40
_0x3F:
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CP   R30,R19
	CPC  R31,R20
	BRNE _0x41
	__GETWRN 19,20,0
;     237         		
;     238    		   if ((dizaines_1 != dizaines) || (etat_1 != etat))
_0x41:
_0x40:
	LDD  R26,Y+25
	LDD  R27,Y+25+1
	CP   R19,R26
	CPC  R20,R27
	BRNE _0x43
	RCALL SUBOPT_0x1C
	BREQ _0x42
_0x43:
;     239         		{
;     240         		  lcd_gotoxy(x,y);
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1D
	RCALL _lcd_gotoxy
;     241         	          lcd_putchar(Table_aff[dizaines]);
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,5
	ADD  R26,R19
	ADC  R27,R20
	RCALL SUBOPT_0x1E
;     242         	          dizaines_1 = dizaines;
	__PUTWSR 19,20,25
;     243         	   	}
;     244         	   switch(BP)
_0x42:
	RCALL SUBOPT_0x1F
;     245         	   	{
;     246         	    	  case INC   : dizaines = dizaines + 1; break;
	BRNE _0x48
	__ADDWRN 19,20,1
	RJMP _0x47
;     247         	    	  case DEC   : dizaines = dizaines - 1; break;
_0x48:
	CPI  R30,LOW(0x2F)
	BRNE _0x49
	__SUBWRN 19,20,1
	RJMP _0x47
;     248         	    	  case OK    : etat = 1; break;
_0x49:
	CPI  R30,LOW(0x37)
	BRNE _0x4A
	RCALL SUBOPT_0x20
	RJMP _0x47
;     249         	   	  case ENTR  : etat = 2; break;
_0x4A:
	CPI  R30,LOW(0x3E)
	BRNE _0x4C
	RCALL SUBOPT_0x21
	RJMP _0x47
;     250         	    	  default    : etat = 0;
_0x4C:
	RCALL SUBOPT_0x22
;     251         	    	}
_0x47:
;     252         	    	  etat_1 = 0; 	   
	RCALL SUBOPT_0x23
;     253 	  break;
	RJMP _0x3D
;     254 	  
;     255 	  case 1 : // Rglage des unites
_0x3E:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x4D
;     256                    if (unites==-1) unites = 15;
	LDD  R26,Y+23
	LDD  R27,Y+23+1
	CPI  R26,LOW(0xFFFF)
	LDI  R30,HIGH(0xFFFF)
	CPC  R27,R30
	BRNE _0x4E
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	STD  Y+23,R30
	STD  Y+23+1,R31
;     257         		else if (unites == 16) unites = 0;  
	RJMP _0x4F
_0x4E:
	LDD  R26,Y+23
	LDD  R27,Y+23+1
	SBIW R26,16
	BRNE _0x50
	LDI  R30,0
	STD  Y+23,R30
	STD  Y+23+1,R30
;     258         		
;     259    		   if ((unites_1 != unites) || (etat_1 != etat))
_0x50:
_0x4F:
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x52
	RCALL SUBOPT_0x1C
	BREQ _0x51
_0x52:
;     260         		{
;     261                           lcd_gotoxy(x+1,y);
	LDD  R30,Y+28
	SUBI R30,-LOW(1)
	ST   -Y,R30
	RCALL SUBOPT_0x1D
	RCALL _lcd_gotoxy
;     262         	          lcd_putchar(Table_aff[unites]);
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,5
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x1E
;     263         	          unites_1 = unites;
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	STD  Y+21,R30
	STD  Y+21+1,R31
;     264         	   	}
;     265         	   switch(BP)
_0x51:
	RCALL SUBOPT_0x1F
;     266         	   	{
;     267         	    	  case INC   : unites = unites + 1; break;
	BRNE _0x57
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ADIW R30,1
	STD  Y+23,R30
	STD  Y+23+1,R31
	RJMP _0x56
;     268         	    	  case DEC   : unites = unites - 1; break;
_0x57:
	CPI  R30,LOW(0x2F)
	BRNE _0x58
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	SBIW R30,1
	STD  Y+23,R30
	STD  Y+23+1,R31
	RJMP _0x56
;     269         	    	  case OK    : etat = 0; break;
_0x58:
	CPI  R30,LOW(0x37)
	BRNE _0x59
	RCALL SUBOPT_0x22
	RJMP _0x56
;     270         	   	  case ENTR  : etat = 2; break;
_0x59:
	CPI  R30,LOW(0x3E)
	BRNE _0x5B
	RCALL SUBOPT_0x21
	RJMP _0x56
;     271         	    	  default    : etat = 1;
_0x5B:
	RCALL SUBOPT_0x20
;     272         	    	}
_0x56:
;     273         	    	  etat_1 = 1; 
	LDI  R18,LOW(1)
;     274 	  break;
	RJMP _0x3D
;     275 	  
;     276 	  case 2 : _lcd_write_data(displayOn0);
_0x4D:
	CPI  R30,LOW(0x2)
	BRNE _0x3D
	RCALL SUBOPT_0x1B
;     277 	  	   return (unsigned char)(16*dizaines + unites);
	__GETW1R 19,20
	RCALL __LSLW4
	LDD  R26,Y+23
	LDD  R27,Y+23+1
	ADD  R30,R26
	ADC  R31,R27
	RJMP _0xD3
;     278 	  break;
;     279 	  
;     280 	}
_0x3D:
;     281    }
	RJMP _0x38
;     282 }
_0xD3:
	RCALL __LOADLOCR5
	ADIW R28,29
	RET
;     283 
;     284  

_Lire_BP:

	.DSEG

	.CSEG
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x24
	MOV  R30,R6
	CPI  R30,0
	BRNE _0x61
	RCALL SUBOPT_0x25
	BRNE _0x62
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0xD
	BRNE _0x63
	LDI  R30,LOW(1)
	MOV  R6,R30
	LDI  R30,LOW(255)
	RJMP _0xD2
_0x63:
	LDI  R30,LOW(0)
	RJMP _0xD2
_0x62:
	LDI  R30,LOW(0)
	RJMP _0xD2
_0x61:
	CPI  R30,LOW(0x1)
	BRNE _0x60
	RCALL SUBOPT_0x25
	BREQ _0x67
	RCALL SUBOPT_0x26
	ANDI R17,LOW(63)
	RCALL SUBOPT_0xD
	BRNE _0x68
	CLR  R6
	MOV  R30,R17
	RJMP _0xD2
_0x68:
	LDI  R30,LOW(255)
	RJMP _0xD2
_0x67:
	LDI  R30,LOW(255)
_0x60:
_0xD2:
	RCALL __LOADLOCR2P
	RET
_Affiche_LCD:
	RCALL _lcd_clear
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x28
	ADIW R28,4
	RET
_Affiche_LCD440:
	RCALL _lcd_clear
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0xA
	RCALL _lcd_gotoxy
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0xB
	RCALL _lcd_gotoxy
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x28
	ADIW R28,8
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x6B
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+2
	STD  Z+0,R26
	RJMP _0x6C
_0x6B:
	RCALL SUBOPT_0x17
	RCALL _putchar
_0x6C:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	RCALL SUBOPT_0x0
_0x6D:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	RCALL SUBOPT_0x2B
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x6F
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x73
	RCALL SUBOPT_0x2C
	BRNE _0x74
	LDI  R16,LOW(1)
	RJMP _0x75
_0x74:
	RCALL SUBOPT_0x2D
_0x75:
	RJMP _0x72
_0x73:
	CPI  R30,LOW(0x1)
	BRNE _0x76
	RCALL SUBOPT_0x2C
	BRNE _0x77
	RCALL SUBOPT_0x2D
	RJMP _0xDA
_0x77:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	RCALL SUBOPT_0x22
	CPI  R19,45
	BRNE _0x78
	RCALL SUBOPT_0x20
	RJMP _0x72
_0x78:
	CPI  R19,43
	BRNE _0x79
	LDI  R21,LOW(43)
	RJMP _0x72
_0x79:
	CPI  R19,32
	BRNE _0x7A
	LDI  R21,LOW(32)
	RJMP _0x72
_0x7A:
	RJMP _0x7B
_0x76:
	CPI  R30,LOW(0x2)
	BRNE _0x7C
_0x7B:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	RCALL SUBOPT_0x2E
	BRNE _0x7D
	ORI  R17,LOW(128)
	RJMP _0x72
_0x7D:
	RJMP _0x7E
_0x7C:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x72
_0x7E:
	RCALL SUBOPT_0x2E
	BRLO _0x81
	RCALL SUBOPT_0x2F
	BRLO _0x82
_0x81:
	RJMP _0x80
_0x82:
	MOV  R18,R20
	LSL  R20
	LSL  R20
	ADD  R20,R18
	LSL  R20
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x72
_0x80:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x86
	RCALL SUBOPT_0x30
	LD   R30,X
	RCALL SUBOPT_0x31
	RJMP _0x87
_0x86:
	CPI  R30,LOW(0x73)
	BRNE _0x89
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x32
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x8A
_0x89:
	CPI  R30,LOW(0x70)
	BRNE _0x8C
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x32
	RCALL _strlenf
	MOV  R16,R30
	RCALL SUBOPT_0x33
_0x8A:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	RCALL SUBOPT_0x23
	RJMP _0x8D
_0x8C:
	CPI  R30,LOW(0x64)
	BREQ _0x90
	CPI  R30,LOW(0x69)
	BRNE _0x91
_0x90:
	ORI  R17,LOW(4)
	RJMP _0x92
_0x91:
	CPI  R30,LOW(0x75)
	BRNE _0x93
_0x92:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x94
_0x93:
	CPI  R30,LOW(0x58)
	BRNE _0x96
	RCALL SUBOPT_0x33
	RJMP _0x97
_0x96:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0xC8
_0x97:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x94:
	RCALL SUBOPT_0x34
	RJMP _0x99
_0x9B:
	RCALL SUBOPT_0x36
_0x9C:
	RJMP _0x9D
_0x99:
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x35
_0x9D:
_0x8D:
	RCALL SUBOPT_0x37
	RJMP _0x9E
_0x9F:
	CP   R16,R20
	BRSH _0xA1
	RCALL SUBOPT_0x38
_0xA2:
	RCALL SUBOPT_0x3A
_0xA5:
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x3B
	RJMP _0x9F
_0xA1:
_0x9E:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0xA6
_0xA7:
	CPI  R18,0
	BREQ _0xA9
	RCALL SUBOPT_0x3C
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xDB:
	ST   -Y,R30
	RCALL SUBOPT_0x3D
	CPI  R20,0
	BREQ _0xAC
	RCALL SUBOPT_0x3B
_0xAC:
	RCALL SUBOPT_0x3E
	RJMP _0xA7
_0xA9:
	RJMP _0xAD
_0xA6:
_0xAF:
	RCALL SUBOPT_0x39
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0xB1:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0xB3
	SUBI R19,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0xB1
_0xB3:
	RCALL SUBOPT_0x2F
	BRLO _0xB4
	RCALL SUBOPT_0x3C
	SUBI R19,-LOW(39)
_0xB4:
	SBRC R17,4
	RJMP _0xB8
	CPI  R19,49
	BRSH _0xBA
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0xB9
_0xBA:
	RJMP _0xDC
_0xB9:
	CP   R20,R18
	BRLO _0xBE
	RCALL SUBOPT_0x37
_0xBE:
	RJMP _0xBD
_0xDC:
	ORI  R17,LOW(16)
	RCALL SUBOPT_0x34
_0xC0:
_0xB8:
	RCALL SUBOPT_0x2D
	CPI  R20,0
	BREQ _0xC3
	RCALL SUBOPT_0x3B
_0xC3:
_0xBD:
	RCALL SUBOPT_0x3E
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRSH _0xAF
_0xAD:
	SBRS R17,0
	RJMP _0xC4
_0xC5:
	CPI  R20,0
	BREQ _0xC7
	RCALL SUBOPT_0x3B
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x31
	RJMP _0xC5
_0xC7:
_0xC4:
_0xC8:
_0x87:
_0xDA:
	LDI  R16,LOW(0)
_0x72:
	RJMP _0x6D
_0x6F:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOV  R26,R28
	MOV  R27,R29
	RCALL __ADDW2R15
	__PUTW2R 16,17
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,6
	RCALL SUBOPT_0x3F
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,4
	RCALL SUBOPT_0x3F
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G4:
	.BYTE 0x4

	.CSEG
__lcd_delay_G4:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G4
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G4
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G4
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G4
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G4:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G4
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G4
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G4
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G4
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble_G4:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G4
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G4
    andi  r30,0xf0
	RET
_lcd_read_byte0_G4:
	RCALL __lcd_delay_G4
	RCALL __lcd_read_nibble_G4
    mov   r26,r30
	RCALL __lcd_read_nibble_G4
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G4)
	SBCI R31,HIGH(-__base_y_G4)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x40
	LDD  R7,Y+1
	LDD  R8,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	RCALL SUBOPT_0xB
	RCALL __lcd_write_data
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x40
	RCALL __lcd_ready
	RCALL SUBOPT_0xA
	RCALL __lcd_write_data
	LDI  R30,LOW(0)
	MOV  R8,R30
	MOV  R7,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R7
	CP   R9,R7
	BRSH _0xCA
	__lcd_putchar1:
	INC  R8
	RCALL SUBOPT_0x9
	ST   -Y,R8
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0xCA:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
	ST   -Y,R16
_0xCB:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R16,R30
	CPI  R30,0
	BREQ _0xCD
	ST   -Y,R16
	RCALL _lcd_putchar
	RJMP _0xCB
_0xCD:
	RCALL SUBOPT_0x1A
	ADIW R28,3
	RET
__long_delay_G4:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G4:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G4
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R9,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G4,2
